// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
var server_url = "https://app.khmer24.com/";
// var server_url          = 'http://192.168.1.168/new-mk24-9/';
var keyword_server_url  = "http://khmer24.website/";
var redirect;
var request_timeout     = 60000;
var trackingID          = 'UA-9169607-6';
var senderID            = 828579838012;

var upload_compress_photo_height = 1500;
var upload_compress_photo_width = 1500;


var app = angular.module('starter', ['ionic','ngCordova','angularLazyImg']);

app.run(function($ionicPlatform, $rootScope, $ionicPopup, $http, $httpParamSerializerJQLike, $cordovaBadge, $cordovaSplashscreen, $cordovaNetwork, $cordovaDevice, $ionicHistory, $state, $timeout, $cordovaAppVersion, $cordovaVibration) {

  $rootScope.not = {};

  $rootScope.connection = 'ON';

  $ionicPlatform.ready(function() {


    if(window.cordova && window.cordova.plugins.Keyboard) {
      // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
      // for form inputs)
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);

      // Don't remove this line unless you know what you are doing. It stops the viewport
      // from snapping when text inputs are focused. Ionic handles this internally for
      // a much nicer keyboard experience.
      cordova.plugins.Keyboard.disableScroll(true);
    }
    if(window.StatusBar) {
      // StatusBar.styleDefault();
      StatusBar.backgroundColorByHexString("#016aaa");
    }

    
    

    // double tab to exit
    document.addEventListener("deviceready", function () {


      $cordovaSplashscreen.hide();

      

      $ionicPlatform.registerBackButtonAction(function(event) {

          event.preventDefault();
          event.stopPropagation();

          var h = $ionicHistory.backView();
          var s = $ionicHistory.currentStateName();
          if(s==='home' || s==='index' || s==='default') {

              $cordovaVibration.vibrate(100);

             var confirmPopup = $ionicPopup.confirm({
                title: 'Khmer24',
               template: $rootScope.lang.con_close_app
             });
             confirmPopup.then(function(res) {
               if(res) {
                 navigator.app.exitApp();
               } else {
               }
             });

          } else {
            if(h) {
              $ionicHistory.goBack();
            } else {
              $state.go('index');
            }
            
          }
      }, 100);

    }, false);



    // register gcm
    $rootScope.device = {};
   document.addEventListener("deviceready", function () {


      // get devide
      $rootScope.device.model = $cordovaDevice.getModel();
      $rootScope.device.platform = $cordovaDevice.getPlatform();
      $rootScope.device.version = $cordovaDevice.getVersion();
      $rootScope.device.uuid = $cordovaDevice.getUUID();
      $rootScope.device.app_version = '';
      $cordovaAppVersion.getVersionNumber().then(function (version) {
        $rootScope.device.app_version = version;
      });

      if(!$rootScope.device.uuid) {
        navigator.app.exitApp();
      }
      // end
      

      $timeout(function(){
        $rootScope.$emit('lazyImg:refresh');
      },350);

      // get connection
      var type = $cordovaNetwork.getNetwork();
      var isOnline = $cordovaNetwork.isOnline();
      var isOffline = $cordovaNetwork.isOffline();

      // listen for Online event
      $rootScope.$on('$cordovaNetwork:online', function(event, networkState){
        var onlineState = networkState;
        $rootScope.connection = "ON";
      });

      // listen for Offline event
      $rootScope.$on('$cordovaNetwork:offline', function(event, networkState){
        var offlineState = networkState;
        // $scope.showAlert('Internet','oOp! No internet connection.');
        $rootScope.connection = "OFF";
      });
      // end





      // PushNotification
      var push = PushNotification.init({
          android: {
              senderID: senderID
          },
          ios: {
              alert: "true",
              badge: "true",
              sound: "true"
          },
          windows: {}
      });

      push.on('registration', function(data) {
          // data.registrationId

              if (data.registrationId.length > 0 ) {
                var submit_data = {};

                submit_data.model = $rootScope.device.model;
                submit_data.version = $rootScope.device.version;
                submit_data.platform = $rootScope.device.platform;
                submit_data.device_id = $rootScope.device.uuid;
                submit_data.app_version = $rootScope.device.app_version;
                
                submit_data.regid = data.registrationId;
              
                var req = {
                 method: 'POST',
                 url: server_url+'save_device',
                 headers: {
                   'Content-Type': 'application/x-www-form-urlencoded'
                 },
                 data: $httpParamSerializerJQLike(submit_data),
                 'timeout':request_timeout,
                };


                $http(req).success(function(response) {

                  if(response.status===1) {
                    window.localStorage.gcm_key = data.registrationId;
                  }                  
                }).error(function(){
                  // $cordovaSplashscreen.hide();
                });
              }



      });

      push.on('notification', function(data) {

        $rootScope.not = data;

        if(data.additionalData.page==='update_app') {
          $state.go('update-app');
          $ionicHistory.nextViewOptions({
            disableAnimate: true,
            disableBack: false
          });
        } else {
          if(data.additionalData.foreground===true) {
            
                $cordovaVibration.vibrate(100);

               // A confirm dialog
               var confirmPopup = $ionicPopup.confirm({
                   title: data.title,
                   template: '<div class="notification_data"><div class="text-center"><img class="img-responsive" lazy-img="'+data.additionalData.picture+'" src="img/khmer24-loading.gif"></div></div>',
                   buttons: [{
                      text: 'Close',
                      type: 'button-default',
                      onTap: function(e) {

                        return false;
                      }
                    }, {
                      text: 'Open',
                      type: 'button-positive',
                      onTap: function(e) {

                        return true;
                      }
                    }]
                 });

                $timeout(function(){
                  $rootScope.$emit('lazyImg:refresh');
                },150);

                 confirmPopup.then(function(res) {
                   if(res) {
                      if(data.additionalData.page==='browser') {
                        $rootScope.open_browser(data.additionalData.param["url"]);
                      } else {

                        if(data.additionalData.page==='listing') {
                          $state.go("listing-by-filter", {"filter":JSON.stringify(data.additionalData.param)});
                        } else {
                          if(data.additionalData.param) {
                            $state.go(data.additionalData.page, data.additionalData.param);
                          } else {
                            $state.go(data.additionalData.page);
                          }
                        }

                          $ionicHistory.nextViewOptions({
                            disableAnimate: true,
                            disableBack: false
                          });

                      }
                   } else {

                   }
                 });

          } else {
              if(data.additionalData.page==='browser') {
                $rootScope.open_browser(data.additionalData.param["url"]);
              } else {
                        if(data.additionalData.page==='listing') {
                          $state.go("listing-by-filter", {"filter":JSON.stringify(data.additionalData.param)});
                        } else {
                          if(data.additionalData.param) {
                            $state.go(data.additionalData.page, data.additionalData.param);
                          } else {
                            $state.go(data.additionalData.page);
                          }
                        }

                $ionicHistory.nextViewOptions({
                  disableAnimate: true,
                  disableBack: false
                });
              }
          }
        }
        
      });

      push.on('error', function(e) {
          // e.message
          // alert(e.message);
      });
      // end



      }, false);




    // check read sms permission
    $rootScope.checkReadSMS = function() {
      document.addEventListener("deviceready", function () {

        var permissions = cordova.plugins.permissions;
        permissions.hasPermission(permissions.READ_SMS, checkPermissionCallback, null);
         
        function checkPermissionCallback(status) {
          if(!status.hasPermission) {
            var errorCallback = function() {
              console.warn('Camera permission is not turned on');
            }
         
            permissions.requestPermission(
              permissions.READ_SMS,
              function(status) {
                if(!status.hasPermission) errorCallback();
              },
              errorCallback);
          }
        }

      }, false);
    };



  });
});





// ##########// ##########// ##########
// ########## rout ##########
// ##########// ##########// ##########
app.config(function($stateProvider,$urlRouterProvider) {
  
  $stateProvider
  .state('home', {
    url: '',
    templateUrl: 'templates/home/index.html'
  })

  .state('index', {
    url: '/index',
    templateUrl: 'templates/home/index.html'
  })

  .state('default', {
    url: '/',
    templateUrl: 'templates/home/index.html'
  })


  // select category
  .state('categories', {
    url: '/category',
    templateUrl: 'templates/home/category.html'
  })

  .state('category', {
    url: '/category/:cat_id/:cat_slug',
    templateUrl: 'templates/home/category.html'
  })

  // listing
  .state('listing', {
    // cache: false,
    url: '/listing',
    templateUrl: 'templates/listing/index.html'
  })

  .state('listing-by-category', {
    url: '/listing/:cat_slug',
    templateUrl: 'templates/listing/index.html'
  })

  .state('listing-by-filter', {
    url: '/listing/:filter',
    templateUrl: 'templates/listing/index.html'
  })

  .state('search', {
    url: '/search/:keyword',
    templateUrl: 'templates/listing/index.html'
  })

  // detail
  .state('detail', {
    cache: false,
    url: '/detail/:adid',
    templateUrl: 'templates/detail/index.html'
  })

  // store
  .state('store', {
    // cache: false,
    url: '/store/:username',
    templateUrl: 'templates/store/index.html'
  })


  // auth
  .state('login', {
    cache: false,
    url: '/login',
    templateUrl: 'templates/auth/login.html'
  })

  .state('register', {
    cache: false,
    url: '/register',
    templateUrl: 'templates/auth/register.html'
  })

  .state('set-phone', {
    cache: false,
    url: '/set-phone',
    templateUrl: 'templates/auth/set-phone.html'
  })

  .state('activate-phone', {
    cache: false,
    url: '/activate-phone',
    templateUrl: 'templates/auth/activate-phone.html'
  })

  .state('send-activate-phone-view', {
    cache: false,
    url: '/send-activate-phone-view',
    templateUrl: 'templates/auth/send-activate-phone-view.html'
  })

  .state('forgot-password', {
    cache: false,
    url: '/forgot-password',
    templateUrl: 'templates/auth/forgot-password.html'
  })

  .state('reset-password', {
    cache: false,
    url: '/reset-password',
    templateUrl: 'templates/auth/reset-password.html'
  })


  // account
  .state('my-account', {
    cache: false,
    url: '/my-account',
    templateUrl: 'templates/account/my-account.html'
  })
  .state('account-setting', {
    cache: false,
    url: '/account-setting',
    templateUrl: 'templates/account/account-setting.html'
  })
  .state('change-password', {
    cache: false,
    url: '/change-password',
    templateUrl: 'templates/account/change-password.html'
  })

  .state('set-map', {
    cache: false,
    url: '/set-map',
    templateUrl: 'templates/account/set-map.html'
  })

  // manage ads
  .state('manage-items', {
    cache: false,
    url: '/manage-items',
    templateUrl: 'templates/items/manage-items.html'
  })

  .state('post-free-item', {
    cache: false,
    url: '/post-free-item',
    templateUrl: 'templates/items/post-free-item.html'
  })

  .state('save-items', {
    cache: false,
    url: '/save-items',
    templateUrl: 'templates/items/save-items.html'
  })

  .state('edit-item', {
    cache: false,
    url: '/edit-item/:adid',
    templateUrl: 'templates/items/post-free-item.html'
  })

  .state('repost-item', {
    cache: false,
    url: '/repost-item/:adid',
    templateUrl: 'templates/items/post-free-item.html'
  })

  // setting
  .state('setting', {
    cache: false,
    url: '/setting',
    templateUrl: 'templates/setting/index.html'
  })

  .state('slide-setting', {
    cache: false,
    url: '/slide-setting',
    templateUrl: 'templates/setting/slide-setting.html'
  })


  // error and 404 page
  .state('404', {
    url: '/404',
    templateUrl: 'templates/page/404.html'
  })
  .state('error', {
    url: '/error',
    templateUrl: 'templates/page/error.html'
  })

  .state('update-app', {
    url: '/update-app',
    templateUrl: 'templates/page/update_app.html'
  });



  // $urlRouterProvider.otherwise(function() {
  //   return '/index';
  // });



});


// ########## main controller ##########
app.controller('starterCtrl', function($scope,$ionicPlatform, $cordovaVibration, $ionicHistory, $ionicPopup, $state, $location, $ionicLoading,$window,$cordovaFacebook, $ionicSideMenuDelegate, $rootScope, $cordovaToast, $cordovaPush, $http, $httpParamSerializerJQLike, $timeout, $ionicActionSheet, $cordovaInAppBrowser, $cordovaGoogleAnalytics) {

  $ionicPlatform.ready(function() {

    // google analytic
    document.addEventListener("deviceready", function () {
        // $cordovaGoogleAnalytics.debugMode();
        // $cordovaGoogleAnalytics.startTrackerWithId(trackingID);

        window.ga.debugMode();
        window.ga.startTrackerWithId(trackingID);
        
    }, false);


    // open in browser
    var inAppBrowserRef = false;
    $rootScope.open_browser = function(url) {
        document.addEventListener("deviceready", function () {
          if(url) {
            var target = "_blank";
            var options = "location=yes,hidden=yes";
            inAppBrowserRef = cordova.InAppBrowser.open(url, target, options);

            $scope.shortAlert("loading please wait ...");
            inAppBrowserRef.show();

            // if(inAppBrowserRef) {
            //     addEventListener('loadstart', loadStartCallBack);
            //     addEventListener('loadstop', loadStopCallBack);
            //     addEventListener('loaderror', loadErrorCallBack);
            // }


          }
        },false);
    };

    function loadStartCallBack() {
        $scope.shortAlert("loading please wait ...");
        inAppBrowserRef.show();
    }

    function loadStopCallBack() {
        if (inAppBrowserRef !== false) {
            // inAppBrowserRef.insertCSS({ code: "body{font-size: 25px;" });
            // $('#status-message').text("");
            // inAppBrowserRef.show();
        }
    }

    function loadErrorCallBack(params) {
        var scriptErrorMesssage = "alert('Sorry we cannot open that page. Message from the server is : "+ params.message + "')"; 
        inAppBrowserRef.executeScript({ code: scriptErrorMesssage }, executeScriptCallBack);
        inAppBrowserRef.close();
        inAppBrowserRef = false;
    }

    function executeScriptCallBack(params) {
        if (params[0] === null) {
            $scope.shortAlert("Sorry we couldn't open that page. Message from the server is : '"+ params.message + "'");
        }
    }

    // end




    // app langouge
    $rootScope.lang_type = 'kh';
    $rootScope.lang = kh_lang;
    if(window.localStorage.lang && window.localStorage.lang !== 'undefined') {
      if(window.localStorage.lang==='eng') {
        $rootScope.lang = eng_lang;
        window.localStorage.lang = 'eng';
        $rootScope.lang_type = 'eng';
      } else {
        $rootScope.lang = kh_lang;
        window.localStorage.lang = 'kh';
        $rootScope.lang_type = 'kh';
      }
    }



    $scope.choose_lang = function(val) {

        if(val===undefined) {
          if($rootScope.lang_type==='kh') {
            val = 'eng';
          } else {
            val = 'kh';
          }
        }

        if(val==='kh') {
          $rootScope.lang = kh_lang;
          window.localStorage.lang = 'kh';
          $rootScope.lang_type = 'kh';
        } else {
          $rootScope.lang = eng_lang;
          window.localStorage.lang = 'eng';
          $rootScope.lang_type = 'eng';
        }

    };

    // end

    // 
    $timeout(function(){
      $rootScope.slideHeader = false;
      $rootScope.slideHeaderPrevious = 0;
    });



    // Toast message
    $scope.shortAlert = function(msg) {
        document.addEventListener('deviceready', function () {
          $cordovaToast.showShortBottom(msg).then(function(success) {
            // success
          }, function (error) {
            // error
          });
        }, false);
        console.log('Toast: '+msg);
    };

    // slide menu
    $scope.toggleLeft = function() {
      $ionicSideMenuDelegate.toggleLeft();
    };

      // An alert dialog
      $scope.showAlert = function(title,message) {
         var alertPopup = $ionicPopup.alert({
           title: title,
           template: message
         });

          document.addEventListener('deviceready', function () {
            $cordovaVibration.vibrate(100);
          }, false);

      };
      // ---- end ----


      // ----back history ----
      $scope.myGoBack = function(disableAnimate) {

        if(disableAnimate===true) {
              $ionicHistory.nextViewOptions({
                disableAnimate: true,
                disableBack: false
              });
        }

        if($ionicHistory.backView()) {
                $ionicHistory.goBack();
        } else {
          $state.go('index');
        }

      };
      // ---- end ----


      // ---- get format time ----
      $scope.fn_formatDate = function(val) {

        var currentdate = new Date();
        currentdate = currentdate.getTime()/1000;

        var newDate = new Date(val);
        var y = newDate.getFullYear();
        var m = pad(newDate.getMonth()+1,2);
        var d = pad(newDate.getDate(),2);
        var h = pad(newDate.getHours(),2);
        var i = pad(newDate.getMinutes(),2);
        var s = pad(newDate.getSeconds(),2);


        newDate = newDate.getTime()/1000;

        var textFormat = '';
        var t = currentdate - newDate;

        var type;
        if(h>12) {
          type = $rootScope.lang.date_am;
        } else {
          type = $rootScope.lang.date_pm;
        }

        if(t<60) {
            textFormat = $rootScope.lang.date_just_now;
        } else if(t<86400) {
            if(t<=60) {
                textFormat = Math.floor(t/60)+' '+$rootScope.lang.date_min;
            } else if(t<3600) {
                textFormat = Math.floor(t/60)+' '+$rootScope.lang.date_mins;
            } else if(t<7200) {
                textFormat = Math.floor(t/60/60)+' '+$rootScope.lang.date_hr;
            } else {
                textFormat = Math.floor(t/60/60)+' '+$rootScope.lang.date_hrs;
            }
        } else if(t<172800) {
            textFormat = $rootScope.lang.date_yesterday;
        } else {
            // textFormat = d+'-'+m+'-'+y+' at '+h+':'+i+':'+s+' '+type;
            textFormat = d+'-'+m+'-'+y;
        }
        return textFormat;
      };

      function pad(number, length) {
          var str = '' + number;
          while (str.length < length) {
              str = '0' + str;
          }
          return str;
      }
      // ---- end ----



      // ----goto url ----
      $scope.goTo = function(url) {
        $state.go(url);
      };
      // ---- end ----

      // ----back history ----



      // get user data
      $scope.user_data = {};
      if(window.localStorage.user && window.localStorage.user!=='undefined') {
        $scope.user_data =  JSON.parse(window.localStorage.user);
      }

      // check is login
      $scope.is_login = function(url) {
        $scope.user_data = {};
        if(window.localStorage.user && window.localStorage.user!=='undefined') {
          $scope.user_data =  JSON.parse(window.localStorage.user);
        }
        if(window.localStorage.access_token && $scope.user_data.userid) {
          if(url) {
              $state.go(url);
          } else {
            return true;
          }
        }
        return false;

      };
      // ---- end ----


      // check is not login
      $scope.is_not_login = function(url) {
        $scope.user_data = {};
        if(window.localStorage.user && window.localStorage.user!=='undefined') {
          $scope.user_data =  JSON.parse(window.localStorage.user);
        }
        if(!window.localStorage.access_token || $scope.user_data.userid) {
              $state.go(url);
        }
      };


      // ----logout ----
      $scope.logout = function(toggleLeft) {

        if(toggleLeft) {
          $scope.toggleLeft();
        }
        // logout fb
        document.addEventListener('deviceready', function () {

          facebookConnectPlugin.logout(function(){
            // sucess
          }, function(){
            // error
          });

        }, false);
        

          var submit_data = {};
          submit_data.userid = $scope.user_data.userid;
          submit_data.access_token = window.localStorage.access_token;

          var req = {
           method: 'POST',
           url: server_url+'logout',
           headers: {
             'Content-Type': 'application/x-www-form-urlencoded'
           },
           data: $httpParamSerializerJQLike(submit_data),
           'timeout':request_timeout,
          };

          $http(req).success(function(response) {

          }).error(function() {
            
          });

        
        window.localStorage.user = '';
        window.localStorage.page_data = '';
        window.localStorage.items_saved = '';
        window.localStorage.access_token = '';

        $ionicHistory.clearHistory();
        $ionicHistory.clearCache();
        
        $state.go('index');



      };
      // ---- end ----


      // ---- check history ----
      $scope.is_has_history = function() {
          if($ionicHistory.backView()) {
            return true;
          }
          return false;
      };


      // ---- get ad image ----
      $scope.image = function(text) {
        if(text && text !== 'undefined') {
          for (var i in text) {
            if(text[i]) {
              
                return text[i];
            }
          }
        }
        return 'img/default-image.png';
      };
      // ---- end ----


    // ---- laoding ----
    $scope.showLoading = function() {
      $ionicLoading.show({
        template: '<div class="loading-box"><ion-spinner class="icon"></ion-spinner> '+$rootScope.lang.txt_loading+'...</div>',
        hideOnStateChange: true,
        noBackdrop: true,
      });
    };
    $scope.hideLoading = function(){
      $ionicLoading.hide();
    };
    // ---- end ----



    // save ad
    $scope.fn_check_item_is_saved = function(id) {
      if($scope.is_login()) {
        var items_saved = window.localStorage.items_saved;
        if(items_saved && items_saved !== "undefined") {
          items_saved = JSON.parse(items_saved);
          for(var v in items_saved) {
            if(items_saved[v].id===id) {
              return true;
            }
          }
        }
      }
      return false;
    };

    $scope.fn_save_item = function(adid) {
      if($scope.is_login()) {
          $scope.showLoading();
          var submit_data = {};
          submit_data.userid = $scope.user_data.userid;
          submit_data.access_token = window.localStorage.access_token;
          submit_data.adid =adid;

          var req = {
           method: 'POST',
           url: server_url+'save_item',
           headers: {
             'Content-Type': 'application/x-www-form-urlencoded'
           },
           data: $httpParamSerializerJQLike(submit_data),
           'timeout':request_timeout,
          };

          $http(req).success(function(response) {

            $scope.hideLoading();
            if(response.status) {
              $scope.is_save_item = true;
              $scope.shortAlert(response.info);

              var d = new Date();
              var items_saved = window.localStorage.items_saved;
              if(items_saved && items_saved !== "undefined") {
                items_saved = JSON.parse(items_saved);
                var val = [];
                    val[0] = {};
                    val[0] = {'id':adid,'date':d};
                  [].push.apply(items_saved, val);
                  // console.log(items_saved);
                  window.localStorage.items_saved =  JSON.stringify(items_saved);
              } else {
                  items_saved = [];
                  items_saved[0] = {};
                  items_saved[0] = {'id':adid,'date':d};
                  window.localStorage.items_saved =  JSON.stringify(items_saved);
              }

            } else {
              $scope.showAlert($rootScope.lang.err_title_save_ad, response.info);
            }
          }).error(function(){
            $scope.hideLoading();
            $scope.shortAlert($rootScope.lang.err_connection);
          });
      } else {
        $state.go('my-account');
      }
    };

    $scope.fn_remove_save_item = function(adid) {
      if($scope.is_login()) {
          $scope.showLoading();
          var submit_data = {};
          submit_data.userid = $scope.user_data.userid;
          submit_data.access_token = window.localStorage.access_token;
          submit_data.adid =adid;

          var req = {
           method: 'POST',
           url: server_url+'remove_save_item',
           headers: {
             'Content-Type': 'application/x-www-form-urlencoded'
           },
           data: $httpParamSerializerJQLike(submit_data),
           'timeout':request_timeout,
          };

          $http(req).success(function(response) {

            $scope.hideLoading();
            if(response.status) {
              $scope.is_save_item = false;
              $scope.shortAlert(response.info);

              var items_saved = window.localStorage.items_saved;
              if(items_saved && items_saved !== "undefined") {
                items_saved = JSON.parse(items_saved);
                for(var v in items_saved) {
                  if(items_saved[v].id===adid) {
                    items_saved.splice(v, 1);
                    window.localStorage.items_saved =  JSON.stringify(items_saved);
                    return;
                  }
                }
              }
            } else {
              $scope.showAlert($rootScope.lang.err_remove_save_ad, response.info);
            }

          }).error(function(){
              $scope.hideLoading();
              $scope.shortAlert($rootScope.lang.err_connection);
          });
      } else {
        $state.go('my-account');
      }
    };
    // end



    // message
    $scope.fn_get_error_message = function(val, title) {
      if((val.$touched || val.$viewValue) && val.$valid===false) {
        var m;
          if(val.$error.required) {
            m = $rootScope.lang.err_form_required;
            return m.replace("%s", title);
          }
          if(val.$error.minlength) {
            m = $rootScope.lang.err_form_minlength;
            return m.replace("%s", title);
          }
          if(val.$error.maxlength) {
            m = $rootScope.lang.err_form_maxlength;
            return m.replace("%s", title);
          }
          if(val.$error.pattern) {
            m = $rootScope.lang.err_form_pattern;
            return m.replace("%s", title);
          }

          m = $rootScope.lang.err_form_default;
          return m.replace("%s", title);
      }
    };



    // update user profile
    $scope.fn_update_user_profile = function() {
        if($scope.is_login()) {

            var submit_data = {};
            submit_data.userid = $scope.user_data.userid;
            submit_data.access_token = window.localStorage.access_token;

            var req = {
             method: 'POST',
             url: server_url+'get_user_data',
             headers: {
               'Content-Type': 'application/x-www-form-urlencoded'
             },
             data: $httpParamSerializerJQLike(submit_data),
             'timeout':request_timeout,
            };

            $http(req).success(function(response) {

              window.localStorage.user     = JSON.stringify(response.user);
              $scope.user_data = response.user;              

            }).error(function(){

            });
        }
    };
    // end


  // get save ads
    $scope.get_saveAds = function() {
      if($scope.is_login()) {
        var submit_data = {};
        submit_data.userid = $scope.user_data.userid;
        submit_data.access_token = window.localStorage.access_token;

        var req = {
         method: 'POST',
         url: server_url+'my_save_items',
         headers: {
           'Content-Type': 'application/x-www-form-urlencoded'
         },
         data: $httpParamSerializerJQLike(submit_data),
         'timeout':request_timeout,
        };

        $http(req).success(function(response) {
            var saveAds = response.save_items;
            var count_saveAds = saveAds.length;

            if(saveAds) {
              var si = [];
              for(var i in saveAds) {
                si[i] = {};
                si[i] ={'id':saveAds[i].id, 'date':saveAds[i].date};
              }
              window.localStorage.items_saved = JSON.stringify(si);
            } else {
              window.localStorage.items_saved = '';

            }

        }).error(function(){
          $scope.shortAlert($rootScope.lang.err_load_save_ads);
        });
      }
    };



    // check access token
    $scope.check_access_token = function(updateUserData) {

      $scope.user_data = {};
      if(window.localStorage.user && window.localStorage.user!=='undefined') {
        $scope.user_data =  JSON.parse(window.localStorage.user);
      }

      if($scope.is_login()) {
          var submit_data = {};
          submit_data.userid = $scope.user_data.userid;
          submit_data.access_token = window.localStorage.access_token;

          document.addEventListener("deviceready", function () {
              submit_data.device_id = $rootScope.device.uuid;
          }, false);

          var req = {
           method: 'POST',
           url: server_url+'check_access_token',
           headers: {
             'Content-Type': 'application/x-www-form-urlencoded'
           },
           data: $httpParamSerializerJQLike(submit_data),
           'timeout':request_timeout,
          };

          $http(req).success(function(response) {
            if(response.status!==1) {
               $scope.logout();
              // $scope.shortAlert(response.info);
              return;
            } else {
              if(updateUserData) {
                $scope.fn_update_user_profile();
                $scope.get_saveAds();
              }
            }
          }).error(function(){
            $timeout(function(){
              $scope.check_access_token();
            },15000);
          });
      }
    };
    $scope.check_access_token(true);

  });

  $scope.add_contact = function(adid,userid) {

            var submit_data = {};
            submit_data.adid = adid;
            submit_data.userid = userid;
            submit_data.platform = 'android';

            var req = {
             method: 'POST',
             url: server_url+'add_statistics',
             headers: {
               'Content-Type': 'application/x-www-form-urlencoded'
             },
             data: $httpParamSerializerJQLike(submit_data),
             'timeout':request_timeout,
            };

            $http(req).success(function(response) {

              console.log(response);

            }).error(function(){

            });

  }

});





// ##########// ##########// ##########
// ########## site controller ##########
// ##########// ##########// ##########




// ########## listing Ad controller ##########
var active_detail_item;
var locations = '';
var update_category = false;

app.controller('listingAdCtrl', function($scope, $ionicPlatform, $http, $ionicHistory, $httpParamSerializerJQLike, $state,  $ionicModal, $ionicPopover, $stateParams, $location, $ionicScrollDelegate, $rootScope, $timeout, $cordovaGoogleAnalytics, $ionicSlideBoxDelegate, $ionicActionSheet, $cordovaSocialSharing) {

$scope.slide_height = (window.screen.height*0.6)+'px';

  $ionicPlatform.ready(function() {

    $scope.server_connection = true;

    $timeout(function(){
      $rootScope.slideHeader = false;
      $rootScope.slideHeaderPrevious = 0;
      $scope.screen_height = window.screen.height;
      $scope.screen_width = window.screen.width;
      // $ionicHistory.clearCache();
      
    });

    


    // switch view 

    $scope.list_h = '130px';
    $scope.list_w = '100%';

    $scope.itemView = 'gallery';
    $scope.show_inline_loading = false;
    // if(window.localStorage.itemView) {
    //   $scope.itemView = window.localStorage.itemView;
    // }
    $scope.fn_switchView = function(view) {
      $ionicHistory.clearCache();
      // $scope.show_inline_loading = true;

        if($scope.show_no_more===true) {
          $scope.show_no_more = false;

          $timeout(function(){
            $scope.show_no_more = true;
          },500);

        }

      if(view==='gallery') {
        $scope.itemView = view;
        window.localStorage.itemView = 'gallery';
        $scope.list_h = '245px';
        $scope.list_w = '50%';
      } else {
        $scope.itemView = 'list';
        window.localStorage.itemView = 'list';
      $scope.list_h = '130px';
      $scope.list_w = '100%';
      }

      // var items = $scope.items;
       $scope.items = [];

      $timeout(function(){
        // $scope.show_inline_loading = false;
        // $scope.items = items;
        $scope.doRefresh();

      },100);

    };
    if($scope.itemView==='gallery') {
        $scope.list_h = '245px';
        $scope.list_w = '50%';
    }

    // 



      // ---- filter----
      $scope.filter_field = '';
      $scope.filter_field_value = '';
      $scope.filter_loading = true;

      // ---- ####----

      $scope.ft = {};
      $scope.submitFilter = function() {
        $scope.items = [];
        per_page = 0;
        request = 0;
        $scope.submit_filter_data = $scope.ft;
        $scope.moreDataCanBeLoaded = true;
        $scope.loadMore();
        $scope.close_more_filter();

      };
      // ---- end ----



      // ---- get the categories  ----

      $scope.categories_loading = true;
      $scope.selectCategory = $rootScope.lang.title_all_categories;
      $scope.active_category = '';
      $scope.active_category_id = 0;
      $scope.active_category_title = $rootScope.lang.title_select_category;

      $scope.categories = window.localStorage.categories;
      if($scope.categories) {
        $scope.categories = JSON.parse($scope.categories);
        $scope.categories_loading = false;
      } else {
        $scope.categories = [];
      }


      $scope.get_categories = function(active_cat_slug) {
        if($scope.categories.length<1 || update_category===false) {

          if($rootScope.connection==='OFF') {
            $scope.shortAlert($rootScope.lang.err_no_connection);
            return;
          }
          if($scope.categories.length<1) {
            $scope.categories_loading = true;
          }
          
          $http.get(server_url+'get_categories').success(function(response) {
            $scope.categories_loading = false;
              $scope.categories = response.categories;
              window.localStorage.categories =  JSON.stringify(response.categories);

              // make select category
              if(active_cat_slug && $scope.categories) {
                for(var v in $scope.categories) {
                  if($scope.categories[v].slug===active_cat_slug) {
                    $scope.active_category = $scope.categories[v].slug;
                    $scope.selectCategory = $scope.categories[v][$rootScope.lang_type+'_name'];
                    break;
                  }
                }
              }
              $timeout(function(){
                $rootScope.$emit('lazyImg:refresh');
              },150);

              update_category = true;

          }).error(function(response){
            $scope.categories_loading = 'error';
            $scope.shortAlert($rootScope.lang.err_connection);
          });
        } else {
          $scope.categories_loading = false;
          $timeout(function(){
            $rootScope.$emit('lazyImg:refresh');
          },150);
        }
      };
      if($stateParams.cat_slug) {
        if($scope.categories) {
              // make select category
              if($stateParams.cat_slug && $scope.categories) {
                for(var v in $scope.categories) {
                  if($scope.categories[v].slug===$stateParams.cat_slug) {
                    $scope.active_category = $scope.categories[v].slug;
                    $scope.selectCategory = $scope.categories[v][$rootScope.lang_type+'_name'];
                    break;
                  }
                }
              }
        } else {
          $scope.get_categories($stateParams.cat_slug);
        }

      }
      $scope.activeCategory = function(id, slug, title, parent) {


        if(parent>0) {
          $scope.active_category = slug;
          $scope.selectCategory = title;

          $scope.items = [];
          per_page = 0;
          request = 0;

          if(slug) {
            request_items_url = server_url+'get_items/'+slug;
          } else {
            request_items_url = server_url+'get_items';
          }

          $scope.closeModal();


          // ---- filter----
          $scope.filter_field = '';
          $scope.filter_field_value = '';
          $scope.filter_loading = true;

          $scope.moreDataCanBeLoaded = true;
          $scope.loadMore();

          // $location.path('/listing/'+slug);

        } else {
          $scope.active_category_id = id;
          $scope.active_category_title = title;
          $scope.active_category_slug = slug;
        }

      };
      // ---- end ----


      // ---- get the locations  ----
      $scope.selectLocation = $rootScope.lang.txt_all_location;
      $scope.locations = locations;
      $scope.active_location = '';
      $scope.locations_loading = true;
      $scope.get_locations = function() {
        if($scope.locations.length===0) {

          if($rootScope.connection==='OFF') {
            $scope.shortAlert($rootScope.lang.err_no_connection);
            $scope.locations_loading = false;
            return;
          }
          $scope.locations_loading = true;
          $http.get(server_url+'get_locations').success(function(response) {
              $scope.locations = response.locations;
              locations = response.locations;
              $scope.locations_loading = false;
          }).error(function(){
            $scope.locations_loading = false;
            $scope.shortAlert($rootScope.lang.err_connection);
          });
        } else {
          $scope.locations_loading = false;
        }
      };

      $scope.activeLocation = function(slug, title) {
        $scope.items = [];
        per_page = 0;
        request = 0;

        $scope.selectLocation = title;
        $scope.active_location = slug;
        $scope.submit_filter_data.location = slug;
        $scope.closeModal();
        $scope.moreDataCanBeLoaded = true;
        $scope.loadMore();
      };
      // ---- end ----




    // ---- scroll load item ----
      $scope.items = [];
      $scope.count_item = [];
      var per_page = 0;
      var request = 0;
      var request_items_url = server_url+'get_items';
      $scope.submit_filter_data = {};
      $scope.num_filter = 0;
      $scope.moreDataCanBeLoaded = true;

      if($stateParams.cat_slug) {
         request_items_url = request_items_url+'/'+$stateParams.cat_slug;
      }


      if($stateParams.filter) {

        var fter = JSON.parse($stateParams.filter);

        for (var key in fter) {
          if (fter.hasOwnProperty(key)) {
            
            if (key == "cat_slug") {
              request_items_url = request_items_url+'/'+fter[key];


              if(fter[key]) {
                if($scope.categories) {
                      // make select category

                        for(var v in $scope.categories) {
                          if($scope.categories[v].slug==fter[key]) {
                            $scope.active_category = $scope.categories[v].slug;
                            $scope.selectCategory = $scope.categories[v][$rootScope.lang_type+'_name'];
                            break;
                          }
                        }

                } else {
                  $scope.get_categories(fter[key]);
                }

              }

              
            } else {
              if (key == "filter") {

                var filter = fter[key];
                for (var fkey in filter) {
                  if (filter.hasOwnProperty(fkey)) {
                    $scope.submit_filter_data[fkey] = filter[fkey];
                  }
                }

              } else {
                $scope.submit_filter_data[key] = fter[key];
              }              
            }
          }
        }
      }


      if($stateParams.keyword) {
        $scope.submit_filter_data.keyword = $stateParams.keyword;
      }


      $scope.isRequest = "";
      var ids = [];
      $scope.loadMore = function(enable_moreDataCanBeLoaded) {
        if(enable_moreDataCanBeLoaded) {
          $scope.server_connection = true;
          $scope.moreDataCanBeLoaded = true;
          request = 0;
        }
        $scope.$broadcast('scroll.refreshComplete');
        $scope.submit_filter_data.per_page = per_page;

        if($scope.moreDataCanBeLoaded===true) {
            
            // if($rootScope.connection==='OFF') {
            //   $scope.shortAlert($rootScope.lang.err_no_connection);
            //   return;
            // }

            if(request>0 && per_page===0) {
              return;
            }

            // console.log($scope.submit_filter_data);

            $scope.isRequest = "Request-loading";

          var req = {
           method: 'GET',
           url: request_items_url+'?'+$httpParamSerializerJQLike($scope.submit_filter_data),
           headers: {
             'Content-Type': 'application/x-www-form-urlencoded'
           },
           'timeout':request_timeout,
          };


            $http(req).success(function(response) {

              if(response.items && response.items.length>0) {

                var new_items = [];

                for (var key in response.items) {                 
                  if(ids.indexOf(response.items[key].id) < 0) {
                    new_items.push(response.items[key]);
                    ids.push(response.items[key].id);
                  } else {
                    console.log(ids.indexOf(response.items[key].id));
                  }
                }

                per_page = per_page+response.items.length;
                [].push.apply($scope.items, new_items);
                
                $scope.$broadcast('scroll.infiniteScrollComplete');


                document.addEventListener("deviceready", function () {
                    // $cordovaGoogleAnalytics.trackView('Listing of '+$scope.selectCategory+' offset '+per_page);
                    window.ga.trackView('Listing of '+$scope.selectCategory+' offset '+per_page);
                }, false);
                $scope.show_no_more = false;

              } else {
                $scope.moreDataCanBeLoaded = false;
                $scope.show_no_more = true;
              }

              $scope.ft = $scope.submit_filter_data;

              $scope.num_filter = $scope.get_num_filter($scope.submit_filter_data);

              $scope.server_connection = true;
              // $timeout(function(){
              //   $rootScope.$emit('lazyImg:refresh');
              // },150);

              $scope.isRequest = "";

          }).error(function(response){

            $scope.isRequest = "error";
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.server_connection = false;
            $scope.moreDataCanBeLoaded = false;
            $scope.shortAlert($rootScope.lang.err_connection);
          });
          request++;
        }
      };

      // ---- end ----
      $scope.get_num_filter = function(val) {
        var n = 0;
        if(val) {
          for(var i in val) {
            if(i!=='per_page' && i!=='keyboard') {
              n++;
            }
          }
        }
        // console.log(n);
        return n;
      };



    // pull down refresh
    $scope.doRefresh = function() {
      active_detail_item = '';
      $scope.items = [];
      ids = [];
      per_page = 0;
      request = 0;
      $scope.moreDataCanBeLoaded = true;
      $scope.show_no_more = false;
      $scope.loadMore();
    };



    // choose category modal
    $scope.open_select_cate = function() {
      $ionicModal.fromTemplateUrl('templates/listing/select-category-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modalCategores = modal;

        $scope.active_category_id = 0;
        $scope.active_category_title = $rootScope.lang.title_select_category;

        $scope.get_categories();
        $scope.modalCategores.show();
      });
    };
    $scope.close_select_cate = function() {
      if($scope.modalCategores) {
        $scope.modalCategores.hide();
        $scope.modalCategores.remove();
      }
    };

    // filter
    $scope.open_more_filter = function() {
      $ionicModal.fromTemplateUrl('templates/listing/more-filter-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modalFilter = modal;

        $scope.get_locations();
        $scope.modalFilter.show();

        if(!$scope.filter_field) {

          if($rootScope.connection==='OFF') {
            $scope.shortAlert($rootScope.lang.err_no_connection);
            return;
          }
          if($scope.active_category) {
            $scope.filter_loading = true;
            $http.get(server_url+'filter/'+$scope.active_category+'?lang='+$rootScope.lang_type).success(function(response) {
                $scope.filter_field = response.field;
                $scope.filter_field_value = response.field_value;
                $scope.filter_loading = false;
            }).error(function(response){
              $scope.filter_loading = false;
              $scope.shortAlert($rootScope.lang.err_connection);
            });
          } else {
            $scope.filter_loading = false;
          }

        }
        
        // $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
      });
    };
    $scope.close_more_filter = function() {
      if($scope.modalFilter) {
        $scope.modalFilter.hide();
        $scope.modalFilter.remove();
      }

    };


    // search modal
    $scope.open_search = function(newPage) {
      $ionicModal.fromTemplateUrl('templates/listing/search-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modalSearch = modal;
        $scope.modalSearch.show();
        setTimeout(function(){ document.getElementById("searchbox").focus(); }, 150);
        $scope.searchNewPage = false;
        if(newPage) {
          $scope.searchNewPage = true;
        }
      });
    };
    $scope.close_search = function() {
      if($scope.modalSearch) {
        $scope.modalSearch.hide();
        $scope.modalSearch.remove();
      }
    };


    // search
    $scope.search_suggestion = '';
    var timer;
    $scope.fn_search_suggestion = function(val) {

            var t = 350;
            if(val.length<3) {
              t=0;
            }
            clearTimeout(timer);
            timer = setTimeout( function() { 

              if($rootScope.connection==='OFF') {
                $scope.shortAlert($rootScope.lang.err_no_connection);
                return;
              }

                $http({
                      method: 'GET',
                       headers: {
                         'Content-Type': 'application/x-www-form-urlencoded'
                       },
                      url: keyword_server_url+'?json=true&q='+val
                    }).then(function successCallback(response) {
                        $scope.search_suggestion = response.data;
                    }, function errorCallback(response) {
                        // $scope.hideLoading();
                });

            },t);
    };

    $scope.submit_search = function(val) {
        $scope.ft.keyword = val;
        $scope.close_search();

        $scope.items = [];
        per_page = 0;
        request = 0;

        if($scope.searchNewPage) {
          $location.path('search/'+val);
        } else {
          $scope.submit_filter_data.keyword = val;
          $scope.moreDataCanBeLoaded = true;
          $scope.loadMore();
        }


    };

    $scope.fn_clear_search_text = function() {
      $scope.ft.keyword = '';
      $scope.search_suggestion = '';
      setTimeout(function(){ document.getElementById("searchbox").focus(); }, 100);
    };




    // sort
    $scope.submit_sort = function(val) {
        $scope.closePopover();
        $scope.items = [];
        per_page = 0;
        request = 0;

        $scope.submit_filter_data.sortby = val;
        $scope.moreDataCanBeLoaded = true;
        $scope.loadMore();

    }; 

    $scope.openPopover = function($event) {
      $ionicPopover.fromTemplateUrl('templates/listing/sort-popover.html', {
        scope: $scope
      }).then(function(popover) {
        $scope.popover = popover;
        $scope.popover.show($event);
      });
      
    };
    $scope.closePopover = function() {
      $scope.popover.hide();
      $scope.popover.remove();
    };


    // clear filter value
    $scope.fn_clear_filter_value = function() {
      $scope.ft = {};
    };

    // end


  // active detail
  $scope.active_item_detail = function(index) {
    active_detail_item = [];
    active_detail_item = $scope.items[index];
    active_detail_item.ad_photo = $scope.items[index].thumb;
  };


  // popup detail
    $scope.detail_item = [];
    $scope.detail_server_connection = true;
    $scope.show_404 = false;
    $scope.show_detail_loading = true;
    $scope.show_detail = function(index) {

      $ionicModal.fromTemplateUrl('templates/listing/detail-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modalDetail = modal;
        $scope.modalDetail.show();
      });



      $scope.detail_item = [];
      $scope.detail_server_connection = true;
      $scope.show_404 = false;
      

      $scope.detail_item = $scope.items[index];
      $scope.detail_item.ad_photo = [];

        $ionicSlideBoxDelegate.update();
        $ionicSlideBoxDelegate.slide(0,0);

      $timeout(function(){
        $scope.detail_item.ad_photo = $scope.items[index].thumb;

      });

      
      $scope.get_detail_item($scope.detail_item.id);


    };

    $scope.close_detail = function() {
      if($scope.modalDetail) {
        $scope.modalDetail.hide();
        $scope.modalDetail.remove();
      }

    };

    var is_track = false;

    $scope.get_detail_item = function(val) {

      $scope.show_detail_loading = true;
      $scope.detail_server_connection =true;
        var detail_url = server_url+'get_item/'+val+'?lang='+$rootScope.lang_type;
        if($scope.user_data.userid) {
          detail_url += '&userid='+$scope.user_data.userid;
        }

        $http({
          method: 'GET',
          url: detail_url
        }).then(function successCallback(response) {

            is_track = false;

            // $scope.hideLoading();
            $scope.show_detail_loading = false;
            $scope.detail_server_connection = true;


            if(!response.data.item.id) {
              // $state.go('404');
              $scope.show_404 = true;
            } else {
              $ionicSlideBoxDelegate.update();

              document.addEventListener("deviceready", function () {
                  // $cordovaGoogleAnalytics.trackView('Detail of '+response.data.item.ad_headline);
                   window.ga.trackView('Detail of '+response.data.item.ad_headline);
              }, false);

            }
            $scope.detail_item = response.data.item;
            $scope.detail_item_field = response.data.field;

            $timeout(function(){
              $rootScope.$emit('lazyImg:refresh');
            },300);
            active_detail_item = '';
          }, function errorCallback(response) {
            // $scope.hideLoading();
            $scope.show_detail_loading = false;
            $scope.shortAlert($rootScope.lang.err_connection);
            $scope.detail_server_connection = false;

          });
    };



   // action for call or sms
   $scope.showActionSheet = function(val, title, icon, type,adid,userid) {

    if(is_track==false) {

      $scope.add_contact(adid,userid);

      is_track = true;
    }

      var options = [];
      for (var i = 0;  i < val.length; i++) {
        options[i] = {'text': '<span class="icon '+icon+'"></span> '+val[i]};
      }

     // Show the action sheet
     var hideSheet = $ionicActionSheet.show({
       buttons: options,
       // destructiveText: 'Delete',
       titleText: title,
       cancelText: 'Cancel',
       cancel: function() {
            // add cancel code..
          },
       buttonClicked: function(index) {
          window.location.href = type+':'+val[index];
         return true;
       }
     });

     // For example's sake, hide the sheet after two seconds
     // $timeout(function() {
     //   hideSheet();
     // }, 2000);

   };
   // end


      // share
      $scope.fn_share = function(subject, message, file, link) {

        // console.log("subject:"+subject+", message:"+message+", img:"+file+", link:"+link);

        document.addEventListener("deviceready", function () {
          $scope.showLoading();

            $cordovaSocialSharing
              .share(message, subject, file, link) // Share via native share sheet
              .then(function(result) {
                // Success!
                $scope.hideLoading();
              }, function(err) {
                // An error occured. Show a message to the user
                $scope.hideLoading();
              });

        },false);
      };





      // image modal
      $scope.openImageModal = function(val) {
        $ionicModal.fromTemplateUrl('templates/detail/image-modal.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function(modal) {
          $scope.image_modal = modal;
          $scope.image_modal.show();
          if(window.StatusBar) {
              window.setTimeout(function() {
                StatusBar.backgroundColorByHexString("#000");
              },150);        
          }

          $timeout(function() {
            if(document.getElementById('detail-image').offsetHeight>10) {
              $scope.screen_height =  document.getElementById('detail-image').offsetHeight-2;
            }
            $ionicSlideBoxDelegate.update();
            
            $ionicSlideBoxDelegate.slide(val);
          });

        });
      };
      
      $scope.close_image = function() {
        if($scope.image_modal) {
          $scope.image_modal.hide();
          if(window.StatusBar) {
              window.setTimeout(function() {
                StatusBar.backgroundColorByHexString("#016aaa");
              },200);        
          }
          $ionicSlideBoxDelegate.enableSlide(true);
          $scope.image_modal.remove();
        }

      };

      // image view
      var zoomLevel;
      var enable_slide = true;

      $scope.fn_zoomingimage = function(index) {
        zoomLevel =  $ionicScrollDelegate.$getByHandle('scrollimage-'+index).getScrollView().__zoomLevel;
        if(zoomLevel>1) {
          if(enable_slide===true) {
            enable_slide = false;
            $ionicSlideBoxDelegate.enableSlide(false);
          }
        } else {
          if(enable_slide===false) {
            $ionicSlideBoxDelegate.enableSlide(true);
            enable_slide = true;
          }
        }
      };

      $scope.fn_zoomimage = function(index) {
        zoomLevel =  $ionicScrollDelegate.$getByHandle('scrollimage-'+index).getScrollView().__zoomLevel;

        if(enable_slide===true) {
          enable_slide = false;
          $ionicSlideBoxDelegate.enableSlide(false);
        }

        if(zoomLevel<2) {
          $ionicScrollDelegate.$getByHandle('scrollimage-'+index).zoomTo(2);
        } else if(zoomLevel<3) {
          $ionicScrollDelegate.$getByHandle('scrollimage-'+index).zoomTo(3);
        } else {
          $ionicScrollDelegate.$getByHandle('scrollimage-'+index).zoomTo(1);
          if(enable_slide===false) {
            $ionicSlideBoxDelegate.enableSlide(true);
            enable_slide = true;
          }
        }
      };

      $scope.slideHasChanged = function(index) {
        $ionicScrollDelegate.$getByHandle('scrollimage-'+index).zoomTo(1);
      };



      // report ads
      $scope.openReportModal = function() {
        $ionicModal.fromTemplateUrl('templates/detail/report-item-modal.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function(modal) {
          $scope.report_modal = modal;
          $scope.report_modal.show();
        });
      };

      $scope.close_report = function() {
        if($scope.report_modal) {
          $scope.report_modal.hide();
          $scope.report_modal.remove();
        }

      };




      $scope.select_report_item = '';
      $scope.fn_select_report_item = function(val) {
        $scope.select_report_item = val;
      };

      $scope.submit_report_item = function() {
        if($scope.select_report_item) {

          if($rootScope.connection==='OFF') {
            $scope.showAlert($rootScope.lang.err_report_ad, $rootScope.lang.err_connection);
            return;
          }

          $scope.showLoading();


            var submit_data = {};
            submit_data.adid = $scope.detail_item.id;
            submit_data.reason = $scope.select_report_item;

            var req = {
             method: 'POST',
             url: server_url+'report_item',
             headers: {
               'Content-Type': 'application/x-www-form-urlencoded'
             },
             data: $httpParamSerializerJQLike(submit_data),
             'timeout':request_timeout,
            };

            $http(req).success(function(response) {
                $scope.hideLoading();
                if(response.status) {
                  $scope.close_report();
                  $scope.select_report_item = '';
                  $scope.shortAlert(response.info);
                } else {
                  $scope.showAlert($rootScope.lang.err_report_ad, response.info);
                }
            }).error(function(){
              $scope.hideLoading();
              $scope.showAlert($rootScope.lang.err_report_ad, $rootScope.lang.err_connection);
            });
          
        } else {
          $scope.showAlert($rootScope.lang.err_report_ad, $rootScope.lang.err_emty_report_ad);
        }
      };




  // google map
    $scope.show_map = function() {
      $ionicModal.fromTemplateUrl('templates/listing/map-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.map_modal = modal;
        $scope.map_modal.show();
        $scope.fn_detail_showMap($scope.detail_item.map);
      });
    };
    $scope.close_map = function() {
      if($scope.map_modal) {
        $scope.map_modal.hide();
        $scope.map_modal.remove();      
      }

    };
    $scope.fn_detail_showMap = function(val) {

      setTimeout(function(){
        var x = Number(val.x);
        var y = Number(val.y);
        var dmap;
        var dmarker;
        var zoom = 15;
        var myLatLng;

        function initialize_map() {
            myLatLng = {lat: x, lng: y};
            dmap = new google.maps.Map(document.getElementById('map2'), {
              center: myLatLng,
              zoom: zoom
            });

            dmarker = new google.maps.Marker({
                position: myLatLng,
                map: dmap,
              });

                
            // for move marker when screen change
            google.maps.event.addDomListener(window, "resize", function() {
              window.setTimeout(function() {
                dmap.panTo(dmarker.getPosition());
              },100);
            });
              
            // document.getElementById('maploading').remove();


            }
            initialize_map();
         }, 150);
      
    };



    // modal
    $scope.fn_modal_save_item = function(adid) {
      if($scope.is_login()) {
        $scope.fn_save_item(adid);
      } else {
        $scope.close_detail();
        $state.go('my-account');
      }
    };


    $scope.$on('$destroy', function() {
      $scope.close_detail();
      $scope.close_map();
      $scope.close_report();
      $scope.close_image();
      $scope.close_search();
      $scope.close_select_cate();
      $scope.close_more_filter();
      if($scope.popover) {
        $scope.popover.remove();
      }
    });

  });

});



// ########## home controller ##########
var update_slide = false;
app.controller('homeCtrl', function($scope,$ionicPlatform, $http, $httpParamSerializerJQLike, $state,  $ionicModal, $stateParams, $timeout, $rootScope, $cordovaGoogleAnalytics, $ionicHistory, $ionicSlideBoxDelegate) {

  $scope.show_loading = true;

  $ionicPlatform.ready(function() {



    document.addEventListener("deviceready", function () {

        var currentdate = new Date();
        currentdate = currentdate.getTime()/1000;

      if (window.localStorage.appRate_setDate) {
        var old_date = window.localStorage.appRate_setDate;
        if (window.localStorage.appRate != 1 && window.localStorage.appRate != 3 && (currentdate-old_date) > 86400) {

          AppRate.preferences.storeAppURL = {
            ios: '1133793397',
            android: 'market://details?id=khmer24.com',
          };
           
          AppRate.promptForRating();

          AppRate.preferences.callbacks.onButtonClicked = function(buttonIndex) {
            // 2 = remind me later
            // 1 = rate it now
            // 3 = no
              window.localStorage.appRate = buttonIndex;
              if (buttonIndex==2) {
                window.localStorage.appRate_setDate = currentdate;
              }
          };

        }
      } else {
        window.localStorage.appRate_setDate = currentdate;
      }


    }, false);




    document.addEventListener("deviceready", function () {
        // $cordovaGoogleAnalytics.trackView('Home');
        window.ga.trackView('Home Page')
    }, false);

    $timeout(function(){
        $ionicHistory.clearHistory();
        $ionicHistory.clearCache();
    });


    $timeout(function(){
      $rootScope.$emit('lazyImg:refresh');
      $ionicSlideBoxDelegate.update();
    },150);

    $scope.slideHasChanged = function(index) {
      $timeout(function(){
        $rootScope.$emit('lazyImg:refresh');
      },150);
    };

    
    $scope.show_slide_loading = true;
    $scope.server_connection = true;

    $scope.slides = [];
    if(window.localStorage.homeSlide) {
      $scope.slides = JSON.parse(window.localStorage.homeSlide);
      $rootScope.$emit('lazyImg:refresh');
      $scope.show_slide_loading = false;
      $scope.show_loading = false;
    }

    $scope.fn_get_slides = function() {


      if($scope.slides.length && update_slide===true) {

        $timeout(function(){
          $rootScope.$emit('lazyImg:refresh');
          $scope.show_slide_loading = false;
          $scope.show_loading = false;
        },300);

      } else {
          if($scope.slides.length<1) {
            $scope.show_slide_loading = true;
          } else {
            $scope.show_loading = false;
          }
          
          var submit_url = server_url+'get_slide';
          var active_banner = window.localStorage.slideSetting;
          if(active_banner) {
            submit_url = submit_url+'?active='+JSON.parse(active_banner);
          }
          $http({
            method: 'GET',
            url: submit_url
          }).then(function successCallback(response) {
                $scope.slides = [];
                $scope.show_slide_loading = false;
                $scope.show_loading = false;
                update_slide = true;
                window.localStorage.homeSlide = JSON.stringify(response.data);

                $timeout(function(){
                  $scope.slides = [];
                  $scope.slides = response.data;
                  $rootScope.$emit('lazyImg:refresh');
                  $ionicSlideBoxDelegate.update();
                },150);

            }, function errorCallback(response) {
              $scope.shortAlert($rootScope.lang.err_connection);
              $scope.server_connection = false;
              $scope.show_slide_loading = false;

              $scope.show_loading = false;
              $scope.show_slide_loading = false;
              $scope.server_connection = false;

          });

      }

    };
    var refresh = false;
    $scope.has_slides = function() {
      if(refresh===false) {
        $timeout(function(){
          $rootScope.$emit('lazyImg:refresh');
          $ionicSlideBoxDelegate.update();
        },150);
        refresh = true;
      }

      return true;
    };


    // load home page
    $scope.fn_reload_home_page = function() {
        $scope.show_loading = true;
        $scope.server_connection = true;
        $scope.get_categories();
        $scope.fn_get_slides();
    };
    $scope.fn_reload_home_page();

    });
});



// ########## listing category ##########
app.controller('categoryCtrl', function($scope, $ionicPlatform, $http, $httpParamSerializerJQLike, $state,  $ionicModal, $ionicPopover, $stateParams, $location, $ionicScrollDelegate, $rootScope) {

  $ionicPlatform.ready(function() {
    $scope.active_cat_slug = $stateParams.cat_slug;
    $scope.active_cat_id = $stateParams.cat_id;
    if(!$scope.active_cat_id) {
      $scope.active_cat_id = 0;
      $scope.active_cat_slug = '';
    }
    $scope.get_categories();
  });

});


// ########## detail ad controller ##########
app.controller('detailAdCtrl', function($scope, $ionicPlatform,$ionicHistory, $http, $httpParamSerializerJQLike, $state,  $ionicModal, $stateParams, $ionicActionSheet, $rootScope, $timeout, $ionicSlideBoxDelegate,$ionicScrollDelegate,$cordovaSocialSharing, $cordovaGoogleAnalytics) {
  

  $scope.slide_height = (window.screen.height*0.6)+'px';
  $ionicPlatform.ready(function() {

    $scope.show_detail_loading = true;
    $scope.show_inline_loading = false;



    $timeout(function() {
      $scope.screen_height = window.screen.height;
      $scope.show_404 = false;
    });

    $timeout(function(){
      $rootScope.slideHeader = false;
      $rootScope.slideHeaderPrevious = 0;
    });


    $timeout(function(){
      $rootScope.$emit('lazyImg:refresh');
    },500);


     $scope.server_connection = true;
     var is_track = false;
      $scope.get_detail_item = function(adid) {
        if(adid) {
          if($rootScope.connection==='OFF') {
            $scope.shortAlert($rootScope.lang.err_no_connection);
            return;
          }
          $scope.server_connection = true;
          // $scope.showLoading();

          var detail_url = server_url+'get_item/'+adid+'?lang='+$rootScope.lang_type;
          if($scope.user_data.userid) {
            detail_url += '&userid='+$scope.user_data.userid;
          }

          $http({
            method: 'GET',
            url: detail_url
          }).then(function successCallback(response) {
            is_track = false;
              // $scope.hideLoading();
              $scope.show_detail_loading = false;
              $scope.show_inline_loading = false;

              if(!response.data.item.id) {
                // $state.go('404');
                $scope.show_404 = true;
              } else {
                $ionicSlideBoxDelegate.update();

                document.addEventListener("deviceready", function () {
                    // $cordovaGoogleAnalytics.trackView('Detail of '+response.data.item.ad_headline);
                    window.ga.trackView('Detail of '+response.data.item.ad_headline);
                }, false);

              }
              $scope.detail_item = response.data.item;
              $scope.detail_item_field = response.data.field;

              $timeout(function(){
                $rootScope.$emit('lazyImg:refresh');
              },300);
              active_detail_item = '';
            }, function errorCallback(response) {
              // $scope.hideLoading();
              $scope.show_detail_loading = false;
              $scope.shortAlert($rootScope.lang.err_connection);
              $scope.server_connection = false;
              $scope.show_inline_loading = false;
            });
        }

      };

      
      // get detail ad
      $scope.detail_item = active_detail_item;
      if(!$scope.detail_item || ($scope.detail_item && $scope.detail_item.id!==$stateParams.adid)) {
        $scope.show_inline_loading = true;
      } else {
        $scope.show_inline_loading = false;
      }

      $scope.get_detail_item($stateParams.adid);
      $scope.adid = $stateParams.adid;




      // report modal
      $scope.openReportModal = function() {
        $ionicModal.fromTemplateUrl('templates/detail/report-item-modal.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function(modal) {
          $scope.report_modal = modal;
          $scope.report_modal.show();
        });
      };

      $scope.close_report = function() {
        if($scope.report_modal) {
          $scope.report_modal.hide();
          $scope.report_modal.remove();
        }

      };


      $scope.select_report_item = '';
      $scope.fn_select_report_item = function(val) {
        $scope.select_report_item = val;
      };

      $scope.submit_report_item = function() {
        if($scope.select_report_item) {

          if($rootScope.connection==='OFF') {
            $scope.showAlert($rootScope.lang.err_report_ad, $rootScope.lang.err_connection);
            return;
          }

          $scope.showLoading();


            var submit_data = {};
            submit_data.adid = $stateParams.adid;
            submit_data.reason = $scope.select_report_item;

            var req = {
             method: 'POST',
             url: server_url+'report_item',
             headers: {
               'Content-Type': 'application/x-www-form-urlencoded'
             },
             data: $httpParamSerializerJQLike(submit_data),
             'timeout':request_timeout,
            };

            $http(req).success(function(response) {
                $scope.hideLoading();
                if(response.status) {
                  $scope.close_report();
                  $scope.select_report_item = '';
                  $scope.shortAlert(response.info);
                } else {
                  $scope.showAlert($rootScope.lang.err_report_ad, response.info);
                }
            }).error(function(){
              $scope.hideLoading();
              $scope.showAlert($rootScope.lang.err_report_ad, $rootScope.lang.err_connection);
            });
          
        } else {
          $scope.showAlert($rootScope.lang.err_report_ad, $rootScope.lang.err_emty_report_ad);
        }
      };



    // map modal
    $scope.show_map = function() {
      $ionicModal.fromTemplateUrl('templates/detail/map-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.map_modal = modal;
        $scope.map_modal.show();
        $scope.fn_detail_showMap($scope.detail_item.map);
      });
    };
    $scope.close_map = function() {
      if($scope.map_modal) {
      $scope.map_modal.hide();
      $scope.map_modal.remove();
      }

    };

    // google map
    $scope.fn_detail_showMap = function(val) {

      setTimeout(function(){
        var x = Number(val.x);
        var y = Number(val.y);
        var dmap;
        var dmarker;
        var zoom = 15;
        var myLatLng;

        function initialize_map() {
            myLatLng = {lat: x, lng: y};
            dmap = new google.maps.Map(document.getElementById('map'), {
              center: myLatLng,
              zoom: zoom
            });

            dmarker = new google.maps.Marker({
                position: myLatLng,
                map: dmap,
              });

                
            // for move marker when screen change
            google.maps.event.addDomListener(window, "resize", function() {
              window.setTimeout(function() {
                dmap.panTo(dmarker.getPosition());
              },100);
            });
              
            // document.getElementById('maploading').remove();

                // console.log(val);

            }
            initialize_map();
         }, 300);
      
    };




         


     // action for call or sms
     $scope.showActionSheet = function(val, title, icon, type, adid, userid) {

        if(is_track==false) {

          $scope.add_contact(adid,userid);

          is_track = true;
        }

        var options = [];
        for (var i = 0;  i < val.length; i++) {
          options[i] = {'text': '<span class="icon '+icon+'"></span> '+val[i]};
        }

       // Show the action sheet
       var hideSheet = $ionicActionSheet.show({
         buttons: options,
         // destructiveText: 'Delete',
         titleText: title,
         cancelText: 'Cancel',
         cancel: function() {
              // add cancel code..
            },
         buttonClicked: function(index) {
            window.location.href = type+':'+val[index];
           return true;
         }
       });

     };
     // end


      // share
      $scope.fn_share = function(subject, message, file, link) {

        // console.log("subject:"+subject+", message:"+message+", img:"+file+", link:"+link);

        document.addEventListener("deviceready", function () {
          $scope.showLoading();

            $cordovaSocialSharing
              .share(message, subject, file, link) // Share via native share sheet
              .then(function(result) {
                // Success!
                $scope.hideLoading();
              }, function(err) {
                // An error occured. Show a message to the user
                $scope.hideLoading();
              });

        },false);
      };



      // image modal
      $scope.openImageModal = function(val) {

        $ionicModal.fromTemplateUrl('templates/detail/image-modal.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function(modal) {
          $scope.image_modal = modal;
          $scope.image_modal.show();
          if(window.StatusBar) {
              window.setTimeout(function() {
                StatusBar.backgroundColorByHexString("#000");
              },150);        
          }

          $timeout(function() {
            if(document.getElementById('detail-image').offsetHeight>10) {
              $scope.screen_height =  document.getElementById('detail-image').offsetHeight-2;
            }
            $ionicSlideBoxDelegate.update();
            $ionicSlideBoxDelegate.slide(val);
          });      

        });
          
      };
      $scope.close_image = function() {
        if($scope.image_modal) {
          $scope.image_modal.hide();
          $scope.image_modal.remove();
        }

      };

      // image view
      var zoomLevel;
      var enable_slide = true;

      $scope.fn_zoomingimage = function(index) {
        zoomLevel =  $ionicScrollDelegate.$getByHandle('scrollimage-'+index).getScrollView().__zoomLevel;
        if(zoomLevel>1) {
          if(enable_slide===true) {
            enable_slide = false;
            $ionicSlideBoxDelegate.enableSlide(false);
          }
        } else {
          if(enable_slide===false) {
            $ionicSlideBoxDelegate.enableSlide(true);
            enable_slide = true;
          }
        }
      };

      $scope.fn_zoomimage = function(index) {
        zoomLevel =  $ionicScrollDelegate.$getByHandle('scrollimage-'+index).getScrollView().__zoomLevel;

        if(enable_slide===true) {
          enable_slide = false;
          $ionicSlideBoxDelegate.enableSlide(false);
        }

        if(zoomLevel<2) {
          $ionicScrollDelegate.$getByHandle('scrollimage-'+index).zoomTo(2);
        } else if(zoomLevel<3) {
          $ionicScrollDelegate.$getByHandle('scrollimage-'+index).zoomTo(3);
        } else {
          $ionicScrollDelegate.$getByHandle('scrollimage-'+index).zoomTo(1);
          if(enable_slide===false) {
            $ionicSlideBoxDelegate.enableSlide(true);
            enable_slide = true;
          }
        }
      };

      $scope.slideHasChanged = function(index) {
        $ionicScrollDelegate.$getByHandle('scrollimage-'+index).zoomTo(1);
      };


    $scope.$on('$destroy', function() {
      $scope.close_map();
      $scope.close_report();
      $scope.close_image();
    });

  });

});



// ########## store controller ##########
app.controller('storeCtrl', function($scope, $ionicPlatform, $http, $httpParamSerializerJQLike, $state,  $ionicModal, $stateParams, $timeout, $rootScope, $cordovaGoogleAnalytics, $ionicScrollDelegate) {

  $ionicPlatform.ready(function() {
    $scope.show_loading_items  = true;
    $scope.show_loading_store  = true;

    $timeout(function(){
      $rootScope.slideHeader = false;
      $rootScope.slideHeaderPrevious = 0;
      // $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
    });


    document.addEventListener("deviceready", function () {
        // $cordovaGoogleAnalytics.trackView('Store of '+$stateParams.username);
        window.ga.trackView('Store of '+$stateParams.username);
    }, false);



    // $scope.items = [];
    $scope.store_data = [];

    $scope.ads_status = $rootScope.lang.info_store_ad;

    // get store profile
    $scope.fn_get_store_data = function() {
      $scope.show_loading_store  = true;
      $http({
        method: 'GET',
        url: server_url+'get_store_data/'+$stateParams.username
      }).then(function successCallback(response) {
          $scope.server_connection = true;
          $scope.show_loading_store  = false;
          $scope.store_data = response.data.store;

          if(!$scope.store_data.name) {
            $scope.store_data.name = $scope.store_data.username;
          }
          var m = $scope.ads_status;
          $scope.ads_status = m.replace("%user", $scope.store_data.name);
        }, function errorCallback(response) {
          $scope.show_loading_store = 'error';
        });
    };


    // get total ads
    $scope.fn_get_total_items = function() {
      // $scope.show_loading_store  = true;
      $http({
        method: 'GET',
        url: server_url+'get_total_user_store_items/'+$stateParams.username
      }).then(function successCallback(response) {
         
          // $scope.show_loading_store  = false;
          $scope.total_items = response.data.total;

          var m = $scope.ads_status;
          $scope.ads_status = m.replace("%total", $scope.total_items);

        }, function errorCallback(response) {
          $scope.show_loading_store = 'error';
        });
    };



// ---- scroll load item ----
    $scope.items = [];
    $scope.count_item = [];
    var per_page = 0;
    var request = 0;
    var request_items_url = server_url+'store/'+$stateParams.username;
    $scope.submit_filter_data = {};
    $scope.num_filter = 0;
    if($rootScope.connection==='ON') {
      $scope.moreDataCanBeLoaded = true;
    } else {
      $scope.moreDataCanBeLoaded = false;
    }


    $scope.loadMore = function(enable_moreDataCanBeLoaded) {

      if(enable_moreDataCanBeLoaded) {
        $scope.server_connection = true;
        $scope.moreDataCanBeLoaded = true;
        request = 0;
      }
      $scope.$broadcast('scroll.refreshComplete');
      $scope.submit_filter_data.per_page = per_page;

      if($scope.moreDataCanBeLoaded===true) {
          
          if($rootScope.connection==='OFF') {
            $scope.shortAlert($rootScope.lang.err_no_connection);
            return;
          }

          if(request>0 && per_page===0) {
            return;
          }


        document.addEventListener("deviceready", function () {
            // $cordovaGoogleAnalytics.trackView('Store of '+$stateParams.username);
            window.ga.trackView('Store of '+$stateParams.username+' - Per Page '+per_page);
        }, false);



          var req = {
           method: 'GET',
           url: request_items_url+'?'+$httpParamSerializerJQLike($scope.submit_filter_data),
           headers: {
             'Content-Type': 'application/x-www-form-urlencoded'
           },
           'timeout':request_timeout,
          };

          $http(req).success(function(response) {
            

            if(response.items.length>0) {
              per_page = per_page+response.items.length;
              [].push.apply($scope.items, response.items);
              
              $scope.$broadcast('scroll.infiniteScrollComplete');
            } else {
              $scope.moreDataCanBeLoaded = false;
            }

            $scope.server_connection = true;
            $scope.show_loading_items  = false;
            $timeout(function(){
              $rootScope.$emit('lazyImg:refresh');
            });

           var m = $scope.ads_status;
           $scope.ads_status = m.replace("%num", $scope.items.length);

        }).error(function(response){
          $scope.server_connection  = false;
          $scope.moreDataCanBeLoaded = false;
          $scope.show_loading_items = 'error';
          $scope.shortAlert($rootScope.lang.err_connection);
        });
        request++;
      }
    };
    // ---- end ----


    // reload store
    $scope.fn_reload_store = function() {
      $scope.loadMore(true);
      $scope.fn_get_total_items();
      $scope.fn_get_store_data();
    };

    $scope.active_detail_item = function(index) {
      active_detail_item = $scope.items[index];
    };

  });
});






// ##########// ##########// ##########
// ########## auth controller ##########
// ##########// ##########// ##########

// login
app.controller('loginCtrl', function($scope, $ionicPlatform, $http, $httpParamSerializerJQLike, $state, $ionicPopup, $cordovaVibration, $ionicHistory, $rootScope, $timeout, $cordovaGoogleAnalytics) {

  $ionicPlatform.ready(function() {

    document.addEventListener("deviceready", function () {
        // $cordovaGoogleAnalytics.trackView('Login');
        window.ga.trackView('Login');
    }, false);



    if($scope.is_login()) {
      $state.go('manage-items');
      $ionicHistory.nextViewOptions({
        disableAnimate: false,
        disableBack: true
      });
      return;
    }

    $rootScope.checkReadSMS();

    $scope.userData = {};
    $scope.submitLogin = function() {
      // console.log($scope.userData);

        if($rootScope.connection==='OFF') {
          $scope.showAlert('Loging Failed!',$rootScope.lang.err_connection);
          return;
        }


        $scope.showLoading();
          var submit_data;
          submit_data = $scope.userData;

          document.addEventListener("deviceready", function () {
              submit_data.device_id = $rootScope.device.uuid;
          }, false);


          var req = {
           method: 'POST',
           url: server_url+'login',
           headers: {
             'Content-Type': 'application/x-www-form-urlencoded'
           },
           data: $httpParamSerializerJQLike(submit_data),
           'timeout':request_timeout,
          };

          $http(req).success(function(response) {
            $scope.hideLoading();
            if(response.status===1) {

                $scope.user_data = response.user;
                window.localStorage.user = JSON.stringify(response.user);
                window.localStorage.access_token = response.access_token;
                window.localStorage.page_data = '';

                if(redirect) {
                  $state.go(redirect);
                  redirect = '';
                } else {
                  $state.go('manage-items');
                }


                $ionicHistory.nextViewOptions({
                  disableAnimate: false,
                  disableBack: true
                });


            } else if(response.status===2) {

              window.localStorage.user   = JSON.stringify(response.user);
              window.localStorage.page_data   = JSON.stringify(response.page_data);

              $state.go('set-phone');

            } else if(response.status===4) {
                window.localStorage.user   = JSON.stringify(response.user);
                window.localStorage.page_data   = JSON.stringify(response.page_data);
                $state.go('send-activate-phone-view');

            } else if(response.status===3) {

                $state.go(response.page_data.page);
                $ionicHistory.nextViewOptions({
                  disableAnimate: false,
                  disableBack: true
                });

            } else {
              $scope.showAlert($rootScope.lang.err_login, response.info);
            }
          }).error(function(response){
            $scope.hideLoading();
            $scope.showAlert($rootScope.lang.err_login,$rootScope.lang.err_connection);
          });

    };
    // end

  });

});





// ########## fb login ##########
app.controller('fbCtrl', function($scope, $ionicPlatform, $http, $httpParamSerializerJQLike, $state, $ionicPopup, $cordovaVibration, $ionicHistory, $rootScope) {

  $ionicPlatform.ready(function() {
    // login with fb
    $scope.fn_fb_login = function() {

        if($rootScope.connection==='OFF') {
          $scope.showAlert('Loging Failed!',$rootScope.lang.err_connection);
          return;
        }


        document.addEventListener('deviceready', function () {
            $scope.showLoading();

            var fbLoginSuccess = function (userData) {

                var submit_data = {};
                submit_data.userData = userData;
                submit_data.device_id = $rootScope.device.uuid;

                  var req = {
                   method: 'POST',
                   url: server_url+'fb_login',
                   headers: {
                     'Content-Type': 'application/x-www-form-urlencoded'
                   },
                   data: $httpParamSerializerJQLike(submit_data),
                   'timeout':request_timeout,
                  };

                  $http(req).success(function(response) {

                        $scope.hideLoading();
                        if(response.status===1) {

                            $scope.user_data = response.user;
                            window.localStorage.user   = JSON.stringify(response.user);
                            window.localStorage.access_token = response.access_token;
                            window.localStorage.page_data = '';

                            if(redirect) {
                              $state.go(redirect);
                              redirect = '';
                            } else {
                              $state.go('manage-items');
                            }

                            $ionicHistory.nextViewOptions({
                              disableAnimate: false,
                              disableBack: true
                            });


                        } else if(response.status===2) {

                          window.localStorage.user   = JSON.stringify(response.user);
                          window.localStorage.page_data   = JSON.stringify(response.page_data);

                          $state.go('set-phone');
                        } else {
                          $scope.showAlert($rootScope.lang.err_login, response.info);
                        }

                  }).error(function(response){
                    $scope.hideLoading();
                    $scope.showAlert($rootScope.lang.err_login,$rootScope.lang.err_connection);
                  });
            };

            facebookConnectPlugin.login(["public_profile", "email", "user_friends"],
                fbLoginSuccess,
                function (error) { $scope.shortAlert($rootScope.lang.err_fb_login); $scope.hideLoading(); }
            );

        }, false);
    };
  });

});


// ########## register controller ##########
app.controller('registerCtrl', function($scope, $ionicPlatform, $http, $httpParamSerializerJQLike, $state, $ionicPopup, $cordovaVibration, $ionicHistory, $rootScope, $cordovaGoogleAnalytics) {

  $ionicPlatform.ready(function() {
    document.addEventListener("deviceready", function () {
        // $cordovaGoogleAnalytics.trackView('Register');
        window.ga.trackView('Register');
    }, false);


    if($scope.is_login()) {
      $state.go('manage-items');
      $ionicHistory.nextViewOptions({
        disableAnimate: false,
        disableBack: true
      });
      return;
    }

    $rootScope.checkReadSMS();

    $scope.userData = {};
    $scope.submit_register = function() {
      // console.log($scope.userData);


        if($rootScope.connection==='OFF') {
          $scope.showAlert($rootScope.lang.err_register_title,$rootScope.lang.err_connection);
          return;
        }

        $scope.showLoading();

          var req = {
           method: 'POST',
           url: server_url+'register',
           headers: {
             'Content-Type': 'application/x-www-form-urlencoded'
           },
           data: $httpParamSerializerJQLike($scope.userData),
           'timeout':request_timeout,
          };

          $http(req).success(function(response) {
            $scope.hideLoading();
            if(response.status===1) {

                // $scope.user_data = response.user;
                // window.localStorage.user   = JSON.stringify(response.user);
                // window.localStorage.access_token = response.access_token;
                // window.localStorage.page_data = '';

                // if(redirect) {
                //   $state.go(redirect);
                //   redirect = '';
                // } else {
                //   $state.go('manage-items');
                // }

                // $ionicHistory.nextViewOptions({
                //   disableAnimate: false,
                //   disableBack: true
                // });


                window.localStorage.user   = JSON.stringify(response.user);
                window.localStorage.page_data   = JSON.stringify(response.page_data);

                $state.go(response.page_data.page);
                $ionicHistory.nextViewOptions({
                  disableAnimate: false,
                  disableBack: true
                });


            } else if(response.status===2) {

                window.localStorage.user   = JSON.stringify(response.user);
                window.localStorage.page_data   = JSON.stringify(response.page_data);

                $state.go(response.page_data.page);
                $ionicHistory.nextViewOptions({
                  disableAnimate: false,
                  disableBack: true
                });

            } else if(response.status===3) {

                $state.go(response.page_data.page);
                $ionicHistory.nextViewOptions({
                  disableAnimate: false,
                  disableBack: true
                });

            } else {
              $scope.showAlert($rootScope.lang.err_register_title, response.info);
            }
          }).error(function(response){
            $scope.hideLoading();
            $scope.showAlert($rootScope.lang.err_register_title,$rootScope.lang.err_connection);
          });

    };
    // 

  });

});


// ########## set phone number controller ##########
app.controller('setPhoneCtrl', function($scope, $ionicPlatform, $http, $httpParamSerializerJQLike, $state, $ionicPopup, $cordovaVibration, $ionicHistory, $rootScope, $cordovaGoogleAnalytics) {

  $ionicPlatform.ready(function() {

    document.addEventListener("deviceready", function () {
        // $cordovaGoogleAnalytics.trackView('Set Phone Number');
        window.ga.trackView('Set Phone Number');
    }, false);


    $rootScope.checkReadSMS();


    if($scope.is_login()) {
      $state.go('manage-items');
      $ionicHistory.nextViewOptions({
        disableAnimate: false,
        disableBack: true
      });
      return;
    }

    var user_data = window.localStorage.user;
    if(user_data && user_data !== "undefined") {
      user_data = JSON.parse(user_data);
    }

    var page_data = window.localStorage.page_data;
    if(page_data && page_data !== "undefined") {
      page_data = JSON.parse(page_data);
    }


    if(page_data.must_activate_phone!==1) {
      $state.go('login');
      return;
    }

    // get phone prefix
    $scope.phone_prefix = [];
    $scope.fn_get_phone_prefix = function() {

          if($rootScope.connection==='OFF') {
            return;
          }

          $scope.showLoading();
          $http.get(server_url+'get_phone_prefix').success(function(response) {
            $scope.hideLoading();
            $scope.phone_prefix = response.prefix;
          }).error(function(response){
            $scope.hideLoading();
            $scope.shortAlert($rootScope.lang.err_connection);
          });

    };


    // submit activate phone
    $scope.phone = {};
    $scope.submit_activate_phone = function() {

        if($rootScope.connection==='OFF') {
          $scope.showAlert($rootScope.lang.err_submit,$rootScope.lang.err_connection);
          return;
        }

          $scope.showLoading();

          var submit_data = {};
          submit_data.prefix =  $scope.phone.prefix;
          submit_data.phone = $scope.phone.prefix+$scope.phone.phone;
          submit_data.userid = user_data.userid;

          var req = {
           method: 'POST',
           url: server_url+'set_phone',
           headers: {
             'Content-Type': 'application/x-www-form-urlencoded'
           },
           data: $httpParamSerializerJQLike(submit_data),
           'timeout':request_timeout,
          };

          $http(req).success(function(response) {

              $scope.hideLoading();
              window.localStorage.page_data = JSON.stringify(response.page_data);

              if(response.status===1) {

                $state.go('activate-phone');

              } else if(response.status===2) {

                $state.go('send-activate-phone-view');

              } else if(response.status===3) {

                window.localStorage.page_data = '';
                $state.go('manage-items');

              } else {
                $scope.showAlert($rootScope.lang.err_activate, response.info);
              }

          }).error(function(response){
            $scope.hideLoading();
            $scope.showAlert($rootScope.lang.err_activate, $rootScope.lang.err_connection);
          });



    };

  });

});


// Forgot password
app.controller('forgotPasswordCtrl', function($scope, $ionicPlatform, $http, $httpParamSerializerJQLike, $state, $ionicPopup, $cordovaVibration, $ionicHistory, $rootScope, $timeout, $cordovaGoogleAnalytics) {

  $ionicPlatform.ready(function() {

    document.addEventListener("deviceready", function () {
        // $cordovaGoogleAnalytics.trackView('Login');
        window.ga.trackView('Forgot Password');
    }, false);



    if($scope.is_login()) {
      $state.go('manage-items');
      $ionicHistory.nextViewOptions({
        disableAnimate: false,
        disableBack: true
      });
      return;
    }

    $rootScope.checkReadSMS();

    $scope.userData = {};
    $scope.submitForgotPassword = function() {
      // console.log($scope.userData);

        if($rootScope.connection==='OFF') {
          $scope.showAlert('Forgot Password Failed!',$rootScope.lang.err_connection);
          return;
        }


        $scope.showLoading();
          var submit_data;
          submit_data = $scope.userData;

          document.addEventListener("deviceready", function () {
              submit_data.device_id = $rootScope.device.uuid;
          }, false);


          var req = {
           method: 'POST',
           url: server_url+'forgot_password',
           headers: {
             'Content-Type': 'application/x-www-form-urlencoded'
           },
           data: $httpParamSerializerJQLike(submit_data),
           'timeout':request_timeout,
          };

          $http(req).success(function(response) {
            $scope.hideLoading();
            if(response.status===1) {


              window.localStorage.user   = JSON.stringify(response.user);
              window.localStorage.page_data   = JSON.stringify(response.page_data);

              $state.go('reset-password');

            } else {
              $scope.showAlert($rootScope.lang.err_login, response.info);
            }
          }).error(function(response){
            $scope.hideLoading();
            $scope.showAlert($rootScope.lang.err_login,$rootScope.lang.err_connection);
          });

    };
    // end

  });

});



// reset password
app.controller('resetPasswordCtrl', function($scope, $ionicPlatform ,$http, $httpParamSerializerJQLike, $state, $ionicPopup, $cordovaVibration, $ionicHistory, $window, $cordovaGoogleAnalytics, $rootScope) {

  $ionicPlatform.ready(function() {

    document.addEventListener("deviceready", function () {
        // $cordovaGoogleAnalytics.trackView('Activate Phone');
        window.ga.trackView('Reset Password Phone');
    }, false);


    $rootScope.checkReadSMS();

    $scope.data = {};

    if($scope.is_login()) {
      $state.go('manage-items');
      $ionicHistory.nextViewOptions({
        disableAnimate: false,
        disableBack: true
      });
      return;
    }
    var page_data = window.localStorage.page_data;
    if(page_data && page_data !== "undefined") {
      page_data = JSON.parse(page_data);
    }

    var user_data = window.localStorage.user;
    if(user_data && user_data !== "undefined") {
      user_data = JSON.parse(user_data);
      $scope.data.phone = user_data.phone;
    }

     // submit activate phone
    $scope.activate_phone_number = page_data.phone;

    
    $scope.reset_password = function() {


          $scope.showLoading();

          var submit_data = {};
          submit_data.code =  $scope.data.code;
          submit_data.userid = user_data.userid;
          submit_data.phone = $scope.data.phone;
          submit_data.new_password = $scope.data.new_password;
          submit_data.con_password = $scope.data.con_password;
          document.addEventListener("deviceready", function () {
              submit_data.device_id = $rootScope.device.uuid;
          }, false);

          var req = {
           method: 'POST',
           url: server_url+'reset_password',
           headers: {
             'Content-Type': 'application/x-www-form-urlencoded'
           },
           data: $httpParamSerializerJQLike(submit_data),
           'timeout':request_timeout,
          };

          $http(req).success(function(response) {

            $scope.hideLoading();

              if(response.status===1) {

                  // clear old data
                  $window.localStorage.clear();
                  $ionicHistory.clearCache();
                  $ionicHistory.clearHistory();

                  // set login
                  $scope.user_data = response.user;
                  window.localStorage.user        = JSON.stringify(response.user);
                  window.localStorage.access_token = response.access_token;
                  window.localStorage.page_data = '';

                  if(redirect) {
                    $state.go(redirect);
                    redirect = '';
                  } else {
                    $state.go('manage-items');
                  }


                $ionicHistory.nextViewOptions({
                  disableAnimate: false,
                  disableBack: true
                });

                $scope.shortAlert($rootScope.lang.success_activate);

              } else {
                $scope.showAlert($rootScope.lang.err_activate, response.info);
              }

          }).error(function(response){
            $scope.hideLoading();
            $scope.showAlert($rootScope.lang.err_activate, $rootScope.lang.err_connection);
          });

    };


    // auto check sms
    document.addEventListener('deviceready', function () {
            if(SMS) SMS.startWatch(function(){
                document.addEventListener('onSMSArrive', function(e){
                     var sms = e.data;
                     var sender = sms.address.toLowerCase();
                     if(sender==='khmer24' || sender==='khmer24.com' || sender==='www.khmer24.com') {
                      var message = sms.body;
                      var code = message.substr(message.length - 4);
                        if(code.length===4) {
                          $scope.data.code = code;
                        }
                     }
                });
            }, function(){
                // alert('failed to start watching');
            });
     }, false);

  });

});



// ########## send code controller ##########
app.controller('activatePhoneCtrl', function($scope, $ionicPlatform ,$http, $httpParamSerializerJQLike, $state, $ionicPopup, $cordovaVibration, $ionicHistory, $window, $cordovaGoogleAnalytics, $rootScope) {

  $ionicPlatform.ready(function() {

    document.addEventListener("deviceready", function () {
        // $cordovaGoogleAnalytics.trackView('Activate Phone');
        window.ga.trackView('Activate Phone');
    }, false);



    $rootScope.checkReadSMS();


    if($scope.is_login()) {
      $state.go('manage-items');
      $ionicHistory.nextViewOptions({
        disableAnimate: false,
        disableBack: true
      });
      return;
    }
    var page_data = window.localStorage.page_data;
    if(page_data && page_data !== "undefined") {
      page_data = JSON.parse(page_data);
    }

    var user_data = window.localStorage.user;
    if(user_data && user_data !== "undefined") {
      user_data = JSON.parse(user_data);
    }

    if(page_data.must_activate_phone!==1) {
      $state.go('login');
      return;
    }

     // submit activate phone
    $scope.activate_phone_number = page_data.phone;

    $scope.data = {};
    $scope.submit_activate_phone = function() {


          $scope.showLoading();

          var submit_data = {};
          submit_data.code =  $scope.data.code;
          submit_data.userid = user_data.userid;
          document.addEventListener("deviceready", function () {
              submit_data.device_id = $rootScope.device.uuid;
          }, false);

          var req = {
           method: 'POST',
           url: server_url+'activate_phone',
           headers: {
             'Content-Type': 'application/x-www-form-urlencoded'
           },
           data: $httpParamSerializerJQLike(submit_data),
           'timeout':request_timeout,
          };

          $http(req).success(function(response) {

            $scope.hideLoading();

              if(response.status===1) {

                  // clear old data
                  $window.localStorage.clear();
                  $ionicHistory.clearCache();
                  $ionicHistory.clearHistory();

                  // set login
                  $scope.user_data = response.user;
                  window.localStorage.user        = JSON.stringify(response.user);
                  window.localStorage.access_token = response.access_token;
                  window.localStorage.page_data = '';

                  if(redirect) {
                    $state.go(redirect);
                    redirect = '';
                  } else {
                    $state.go('manage-items');
                  }


                $ionicHistory.nextViewOptions({
                  disableAnimate: false,
                  disableBack: true
                });

                $scope.shortAlert($rootScope.lang.success_activate);

              } else {
                $scope.showAlert($rootScope.lang.err_activate, response.info);
              }

          }).error(function(response){
            $scope.hideLoading();
            $scope.showAlert($rootScope.lang.err_activate, $rootScope.lang.err_connection);
          });

    };


    // auto check sms
    document.addEventListener('deviceready', function () {
            if(SMS) SMS.startWatch(function(){
                document.addEventListener('onSMSArrive', function(e){
                     var sms = e.data;
                     var sender = sms.address.toLowerCase();
                     if(sender==='khmer24' || sender==='khmer24.com' || sender==='www.khmer24.com') {
                      var message = sms.body;
                      var code = message.substr(message.length - 4);
                        if(code.length===4) {
                          $scope.data.code = code;
                        }
                     }
                });
            }, function(){
                // alert('failed to start watching');
            });
     }, false);

  });

});


// ########## max send code view controller ##########
app.controller('sendActivatePhoneViewCtrl', function($scope, $ionicPlatform, $http, $httpParamSerializerJQLike, $state, $ionicPopup, $cordovaVibration, $ionicHistory, $cordovaGoogleAnalytics) {

  $ionicPlatform.ready(function() {

    document.addEventListener("deviceready", function () {
        // $cordovaGoogleAnalytics.trackView('Send Activate Phone');
        
        window.ga.trackView('Send Activate Phone');
    }, false);


    if($scope.is_login()) {
      $state.go('manage-items');
      $ionicHistory.nextViewOptions({
        disableAnimate: false,
        disableBack: true
      });
      return;
    }

     var page_data = window.localStorage.page_data;
     if(page_data && page_data !== "undefined") {
      page_data = JSON.parse(page_data);
     }

    if(page_data.must_activate_phone!==1) {
      $state.go('login');
      $ionicHistory.nextViewOptions({
        disableAnimate: false,
        disableBack: true
      });
      return;
    }

     // submit activate phone
    $scope.page_data = page_data;
    window.localStorage.page_data = '';

  });

});








// ##########// ##########// ##########
// ########## ads controller ##########
// ##########// ##########// ##########



// ########## manage items ##########
app.controller('manageAdsCtrl', function($scope, $ionicPlatform, $state, $http, $httpParamSerializerJQLike, $ionicPopup, $cordovaVibration, $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer, $timeout,  $ionicModal, $ionicHistory, $stateParams, $rootScope, $cordovaGoogleAnalytics) {

  $ionicPlatform.ready(function() {

    if(!$scope.is_login()) {
      redirect = 'manage-items';
      $state.go('my-account');
        $ionicHistory.nextViewOptions({
          disableAnimate: false,
          disableBack: true
        });
        return;
    }


    document.addEventListener("deviceready", function () {
        // $cordovaGoogleAnalytics.trackView('Manage Ads');
        window.ga.trackView('Manage Ads');
    }, false);



    $timeout(function(){
      $scope.check_access_token();
    });

    $scope.show_loading_items = true;

    $scope.server_connection = true;


    
    setTimeout(function(){ $rootScope.$emit('lazyImg:refresh'); }, 300);

    // ---- scroll load item ----
    $scope.item_type = 'active';
    $scope.userAds = [];
    $scope.count_userAds = 0;

    var per_page = 0;
    var request = 0;
    var request_items_url = server_url+'manage_items';
    var submit_data = {};

    if($rootScope.connection==='ON') {
      $scope.moreDataCanBeLoaded = true;
    } else {
      $scope.moreDataCanBeLoaded = false;
    }


    $scope.loadMore = function(enable_moreDataCanBeLoaded) {

      if(enable_moreDataCanBeLoaded) {
        $scope.server_connection = true;
        $scope.moreDataCanBeLoaded = true;
        request = 0;
      }
      $scope.$broadcast('scroll.refreshComplete');
      submit_data.per_page = per_page;
      submit_data.userid = $scope.user_data.userid;
      submit_data.access_token = window.localStorage.access_token;


      if($scope.moreDataCanBeLoaded===true) {
          
          if($rootScope.connection==='OFF') {
            $scope.shortAlert($rootScope.lang.err_no_connection);
            return;
          }

          if(request>0 && per_page===0) {
            return;
          }

          var req = {
           method: 'POST',
           url: request_items_url,
           headers: {
             'Content-Type': 'application/x-www-form-urlencoded'
           },
           data: $httpParamSerializerJQLike(submit_data),
           'timeout':request_timeout,
          };

          $http(req).success(function(response) {

            if(response.count_items>0) {

              per_page = per_page+response.count_items;
              [].push.apply($scope.userAds, response.items);


              
              if($scope.userAds) {
                $scope.count_userAds = $scope.userAds.length;
              }


              $scope.$broadcast('scroll.infiniteScrollComplete');
            } else {
              $scope.moreDataCanBeLoaded = false;
            }
            $scope.show_loading_items = false;
            $scope.server_connection = true;
            $timeout(function(){
              $rootScope.$emit('lazyImg:refresh');
            });

        }).error(function(){
          $scope.server_connection = false;
          $scope.moreDataCanBeLoaded = false;
          $scope.show_loading_items = false;
          $scope.shortAlert($rootScope.lang.err_connection);
        });
        request++;
      }
    };

    // ---- end ----



    // get total ads
    $scope.fn_get_total_items = function() {
      // $scope.show_loading_store  = true;

      var submit_data = {};
      submit_data.userid = $scope.user_data.userid;
      submit_data.access_token = window.localStorage.access_token;

      var req = {
       method: 'POST',
       url: server_url+'get_total_user_items',
       headers: {
         'Content-Type': 'application/x-www-form-urlencoded'
       },
       data: $httpParamSerializerJQLike(submit_data),
       'timeout':request_timeout,
      };

      $http(req).success(function(response) {

          // $scope.show_loading_store  = false;
          $scope.total_userads = response.total;
          $scope.total_active_items = response.total_active_items;
          $scope.total_expire_items = response.total_expire_items;


          var m = $rootScope.lang.info_ads;
          m = m.replace("%name", $scope.user_data.name);
          m = m.replace("%num", $scope.total_userads);
          $scope.ads_sataus = m;

        }).error(function(){
          
        });
    };



    // delte item
    $scope.deleteItem = function(id,index) {

       var confirmPopup = $ionicPopup.confirm({
         title: 'Delete Ad',
         template: $rootScope.lang.con_delete_ad
       });

        document.addEventListener('deviceready', function () {
          $cordovaVibration.vibrate(100);
        }, false);

       confirmPopup.then(function(res) {
         if(res) {
            $scope.showLoading();

            var submit_data = {};
            submit_data.userid = $scope.user_data.userid;
            submit_data.access_token = window.localStorage.access_token;
            submit_data.adid = id;
            submit_data.type = $scope.item_type;

            var req = {
             method: 'POST',
             url: server_url+'delete_item',
             headers: {
               'Content-Type': 'application/x-www-form-urlencoded'
             },
             data: $httpParamSerializerJQLike(submit_data),
             'timeout':request_timeout,
            };

            $http(req).success(function(response) {
              $scope.hideLoading();
              if(response.status) {
                $scope.userAds.splice(index, 1);
                $scope.count_userAds = $scope.userAds.length;
                $scope.total_userads = $scope.total_userads-1;

                if($scope.item_type==='expired') {
                  $scope.total_expire_items = $scope.total_expire_items-1;
                } else {
                  $scope.total_active_items = $scope.total_active_items-1;
                }

              } else {
                $scope.showAlert($rootScope.lang.err_delete, response.info);
              }
            }).error(function(){
              $scope.hideLoading();
              $scope.showAlert($rootScope.lang.err_delete, $rootScope.lang.err_connection);
            });

         } else {

         }
       });


    };




  // renew
  $scope.renewAd = function(id,index) {

      $scope.showLoading();

      var submit_data = {};
      submit_data.userid = $scope.user_data.userid;
      submit_data.access_token = window.localStorage.access_token;
      submit_data.adid = id;

      var req = {
       method: 'POST',
       url: server_url+'renew_item',
       headers: {
         'Content-Type': 'application/x-www-form-urlencoded'
       },
       data: $httpParamSerializerJQLike(submit_data),
       'timeout':request_timeout,
      };

      $http(req).success(function(response) {

        $scope.hideLoading();

        if(response.status) {
          $scope.userAds[index].renew_date = response.date;
          $scope.shortAlert(response.info);
        } else {
          $scope.showAlert($rootScope.lang.err_renew, response.info);
        }
      }).error(function(){
        $scope.hideLoading();
        $scope.showAlert($rootScope.lang.err_renew, $rootScope.lang.err_connection);
      });
  };


    // pull down refresh
    $scope.doRefresh = function() {
      $scope.userAds = [];
      $scope.count_userAds = [];

      per_page = 0;
      request = 0;
      $scope.show_loading_items = true;
      $scope.moreDataCanBeLoaded = true;
      $scope.loadMore();
      $scope.fn_get_total_items();
    };


    // check is renwe
    $scope.is_renew = function(val) {
      var date1 = new Date(val);
      var d1 = date1.getDate();
      var m1 = date1.getMonth();
      var y1 = date1.getYear();

      var date2 = new Date();
      var d2 = date2.getDate();
      var m2 = date2.getMonth();
      var y2 = date2.getYear();

      if(y1>=y2 && m1>=m2 && d1>=d2) {
        return true;
      }

      return false;
    };

    // get expired item
    $scope.fn_get_expired_items = function() {

      $scope.userAds = [];
      $scope.count_userAds = 0;

      per_page = 0;
      request = 0;
      $scope.moreDataCanBeLoaded = true;
      $scope.show_loading_items = true;
      submit_data.type = 'expired';
      $scope.item_type = 'expired';
      $scope.loadMore();
    };

    // get active item
    $scope.fn_get_active_items = function() {

      $scope.userAds = [];
      $scope.count_userAds = 0;

      per_page = 0;
      request = 0;
      $scope.moreDataCanBeLoaded = true;
      $scope.show_loading_items = true;
      submit_data.type = 'active';
      $scope.item_type = 'active';
      $scope.loadMore();
    };
  });

});



// ########## post ad ##########
app.controller('postAdsCtrl', function($scope, $ionicPlatform, $state, $http, $rootScope, $httpParamSerializerJQLike, $ionicPopup, $cordovaVibration, $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer, $timeout,  $ionicModal, $ionicHistory, $stateParams, $ionicActionSheet, $ionicScrollDelegate, $cordovaGoogleAnalytics) {

  $ionicPlatform.ready(function() {

    if(!$scope.is_login()) {
      redirect = 'post-free-item';
      $state.go('my-account');
        $ionicHistory.nextViewOptions({
          disableAnimate: false,
          disableBack: true
        });
        return;
    }




    document.addEventListener("deviceready", function () {
        // $cordovaGoogleAnalytics.trackView('Post Ad');
        window.ga.trackView('Post Ad');
    }, false);


    var stateName = $ionicHistory.currentStateName();

    $timeout(function(){
      $scope.check_access_token();
      $scope.show_404 = false;
    }); 


    $scope.server_connection = true;

    $timeout(function(){
      $scope.show_check_item_Loading = true;
    });

    $scope.item_data = {};
    $scope.item_data.name = $scope.user_data.name;
    $scope.item_data.phone = $scope.user_data.phone;
    $scope.item_data.email = $scope.user_data.email;
    $scope.item_data.location = $scope.user_data.location;
    $scope.item_data.address = $scope.user_data.address;

    $scope.item_image = {};




    // pull down refresh
    $scope.doRefresh = function() {
      $scope.is_can_post();
    };



    // ---- ad photo  ----

        $scope.upload_images = {};

        var numImg = 0;
        var allowNumPhoto = 8;
        var total_image = 0;

        // edit ads
        $scope.editItem = function(id) {
                
                $scope.show_check_item_Loading = true;
                $scope.can_post = false;

                var submit_data = {};
                submit_data.userid = $scope.user_data.userid;
                submit_data.access_token = window.localStorage.access_token;
                submit_data.adid = id;

                if(stateName==='repost-item') {
                  submit_data.type = 'repost_ad';
                }

                var req = {
                 method: 'POST',
                 url: server_url+'get_edit_item?lang='+$rootScope.lang_type,
                 headers: {
                   'Content-Type': 'application/x-www-form-urlencoded'
                 },
                 data: $httpParamSerializerJQLike(submit_data),
                 'timeout':request_timeout,
                };

                $http(req).success(function(response) {

                  if(response.status) {
                    // $scope.getAd = response.ad;


                    $scope.item_data =  response.ad;

                    $scope.item_data.id = $stateParams.adid;

                    $scope.upload_images = {};
                    if($scope.item_data.ad_photo) {

                      numImg = Object.keys($scope.item_data.ad_photo).length;

                      for(var i_old = 1; i_old <= numImg; i_old++) {
                        if($scope.item_data.ad_photo[i_old]) {
                          $scope.upload_images[i_old] = {};
                          $scope.upload_images[i_old].name  = $scope.item_data.ad_photo[i_old].image_name;
                          $scope.upload_images[i_old].image  = $scope.item_data.ad_photo[i_old].image_url;
                          $scope.upload_images[i_old].uploading  = false;
                          $scope.item_image[i_old]  = $scope.item_data.ad_photo[i_old].image_name;
                        }
                      }
                    }

                    if($scope.item_data.phone && $scope.item_data.phone.length>=3) {
                      $scope.show_item_phone_more = false;
                    }

                    $scope.get_categories();

                    // $scope.get_filter($scope.item_data.cateid);

                    $scope.filter_field = response.field;
                    $scope.filter_value = response.field_value;

                    // console.log(response.field);

                    $scope.can_post = true;

                    $scope.show_check_item_Loading = false;
                  } else {
                    $scope.show_404 = true;
                    $scope.show_check_item_Loading = false;
                  }
                }).error(function(){
                  $scope.show_check_item_Loading = false;
                  $scope.shortAlert($rootScope.lang.err_connection);
                });
          
          $scope.$broadcast('scroll.refreshComplete');
        };



  // check for max post
  $scope.can_post = '';
  $scope.is_can_post = function () {
    $scope.$broadcast('scroll.refreshComplete');
    $scope.server_connection = true;
    if($stateParams.adid || stateName==='repost-item') {
      $scope.editItem($stateParams.adid);
      return;
    }

    if($rootScope.connection==="OFF") {
      $scope.show_check_item_Loading = false;
      return;
    }

      $scope.can_post = true;
      $scope.show_check_item_Loading = false;


      // var submit_data = {};
      // submit_data.userid = $scope.user_data.userid;
      // submit_data.access_token = window.localStorage.access_token;

      // var req = {
      //  method: 'POST',
      //  url: server_url+'is_can_post',
      //  headers: {
      //    'Content-Type': 'application/x-www-form-urlencoded'
      //  },
      //  data: $httpParamSerializerJQLike(submit_data),
      //  'timeout':request_timeout,
      // };

      // $http(req).success(function(response) {
      //   $scope.hideLoading();
      //   if(response.status) {
      //       $scope.can_post = true;

      //       $scope.item_data.location =$scope.user_data.location;
      //       $scope.item_data.address =$scope.user_data.address;
      //       $scope.item_data.phone = $scope.user_data.phone;
      //       $scope.item_data.email =$scope.user_data.email;
      //       $scope.item_data.name =$scope.user_data.name;


      //   } else {
      //       $scope.can_post = false;
      //   }
      //   $scope.show_check_item_Loading = false;
        
      //   $scope.server_connection = true;
      // }).error(function(){
      //   $scope.show_check_item_Loading = false;
      //   $scope.server_connection = false;
      // });

  };
  $scope.is_can_post();


    // ---- get the locations  ----

    $scope.locations = locations;
    $scope.get_locations = function() {
      if($scope.locations.length===0) {
        $http.get(server_url+'get_locations').success(function(response) {
            $scope.locations = response.locations;
            locations = response.locations;
        });
      }
    };
    // ---- end ----


    // ---- get the categories  ----
    $scope.categories = window.localStorage.categories;
    if($scope.categories) {
        $scope.categories = JSON.parse($scope.categories);
    } else {
      $scope.categories = [];
    }
    $scope.category_loading = true;
    $scope.get_categories = function() {
      $scope.category_loading = true;
      if($scope.categories.length===0 || update_category===false) {
        $http.get(server_url+'get_categories').success(function(response) {
            $scope.categories = response.categories;
            window.localStorage.categories = JSON.stringify(response.categories);
            $scope.category_loading = false;
            update_category = true;
        }).error(function(){
          $scope.category_loading = 'error';
        });
      } else {
        $scope.category_loading = false;
      }
    };
    // ---- end ----



    // ---- popup select categoties  ----


    $scope.openModal = function() {
      $ionicModal.fromTemplateUrl('templates/items/select-category-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modalCategores = modal;
        $scope.active_category_id = 0;
        $scope.active_category_title = $rootScope.lang.title_choose_a_category;

        $scope.get_categories();
        $scope.modalCategores.show();
      });

    };

    $scope.closeModal = function() {
      if($scope.modalCategores) {
        $scope.modalCategores.hide();
        $scope.modalCategores.remove();        
      }

    };
  $scope.$on('$destroy', function() {
    $scope.closeModal();
  });
    // ---- end ----



    // ---- get filter  ----
    $scope.filter_field = {};
    $scope.filter_value = {};
    $scope.get_filter = function(id) {

      $scope.showLoading();


      var submit_data = {};
      submit_data.userid = $scope.user_data.userid;
      submit_data.access_token = window.localStorage.access_token;

      var req = {
       method: 'POST',
       url: server_url+'get_post_filter/'+id+'?lang='+$rootScope.lang_type,
       headers: {
         'Content-Type': 'application/x-www-form-urlencoded'
       },
       data: $httpParamSerializerJQLike(submit_data),
       'timeout':request_timeout,
      };

      $http(req).success(function(response) {
          $scope.filter_field = response.field;
          $scope.filter_value = response.field_value;
          $scope.hideLoading();
        }).error(function(){
          $scope.hideLoading();
          $scope.shortAlert($rootScope.lang.err_connection);
        });
    };
    // ---- end ----



    // ---- on select categoties  ----
    $scope.active_category_id = 0;
    $scope.active_category_title = $rootScope.lang.title_choose_a_category;

    $scope.selectCategory = function(id, title, parent) {

      if(parent>0) {
          $scope.item_data.cateid = id;
          $scope.closeModal();
          $scope.get_filter(id);
      } else {
        $scope.active_category_id = id;
        $scope.active_category_title = title;
      }


    };

    // ---- end ----






        // photo
        document.addEventListener('deviceready', function () {



            // ######### camara #########
            $scope.openCamra = function() {

                var options = {
                  quality: 90,
                  destinationType: Camera.DestinationType.FILE_URI,
                  sourceType: Camera.PictureSourceType.CAMERA,
                  targetWidth: upload_compress_photo_width,
                  targetHeight: upload_compress_photo_height,
                  correctOrientation:true,
                  saveToPhotoAlbum: true,
                };

                $cordovaCamera.getPicture(options).then(function(imageURI) {

                  // var image = document.getElementById('myImage');
                  // image.src = imageURI;
                  // fileURL = imageURI;

                  for(var i_img=1; i_img<=allowNumPhoto; i_img++) {
                    if ($scope.upload_images[i_img] === undefined) {
                      $scope.upload(imageURI, i_img);
                      $scope.upload_images[i_img] = {};
                      $scope.upload_images[i_img].image = imageURI;
                      $scope.upload_images[i_img].name = '';
                      $scope.upload_images[i_img].uploading = true;

                      break;

                    }
                  }



                }, function(err) {
                  // error
                  // $scope.showAlert('Open Camera', 'Cannot detect camara.');
                });
            };


            // ######### browse photo #########
            $scope.browsePhotos = function() {


              var permissions = cordova.plugins.permissions;
              permissions.hasPermission(permissions.READ_EXTERNAL_STORAGE, checkPermissionCallback, null);
               
              function checkPermissionCallback(status) {

                if(status.hasPermission) {


                var count = allowNumPhoto-total_image;
                 var options = {
                   maximumImagesCount: count,
                   width: upload_compress_photo_width,
                   height: upload_compress_photo_height,
                   quality: 90
                  };

                  $cordovaImagePicker.getPictures(options)
                    .then(function (results) {
                      for (var i = 0; i < results.length; i++) {
                        // fileURL = results[i];

                        for(var i_img=1; i_img<=allowNumPhoto; i_img++) {
                          if ($scope.upload_images[i_img] === undefined) {

                            $scope.upload(results[i], i_img);
                            $scope.upload_images[i_img] = {};
                            $scope.upload_images[i_img].image = results[i];
                            $scope.upload_images[i_img].name = '';
                            $scope.upload_images[i_img].uploading = true;

                            break;

                          }
                        }


                      }
                    }, function(error) {
                      // error getting photos
                      // alert('err');
                    });



                }


                if(!status.hasPermission) {
                  var errorCallback = function() {
                    console.warn('READ_EXTERNAL_STORAGE permission is not turned on');
                  }
               
                  permissions.requestPermission(
                    permissions.READ_EXTERNAL_STORAGE,
                    function(status) {
                      if(!status.hasPermission) { errorCallback(); }

                      if(status.hasPermission) {
                          $scope.browsePhotos();
                      }

                    },
                    errorCallback);
                }
              }


            };


            // upload
            $scope.uploadPersent = [];
            $scope.upload = function(fileURL, index) {

                $scope.uploadPersent[index] = 0;

                  function win(r) {
                      var respon_data = JSON.parse(r.response);


                      if(respon_data.status) {
                        $scope.upload_images[index].name  = respon_data.file;
                        
                        // $scope.upload_images[index].image = respon_data.thumb;
                        $scope.item_image[index]  = respon_data.file;

                        $timeout(function(){
                          $scope.upload_images[index].uploading  = false;
                          document.getElementById("status"+index).remove();
                          document.getElementById("loading"+index).remove();
                        },1000);    

                      } else {
                        $scope.removeImages(index);
                        $scope.showAlert('Upload failed!!!', respon_data.info);
                      }
                  }

                  function fail(error) {

                      $scope.removeImages(index);

                      // alert("An error has occurred: Code = " + error.code);
                      var msg;
                      if(error.code===1) {
                        msg = 'File not found. Please try again!';
                      }
                      if(error.code===2) {
                        msg = 'Invalid url. Please try again!';
                      }
                      if(error.code===3) {
                        msg = 'Check your connection and try again.';
                      }
                      if(error.code===4) {
                        msg = 'The uploading photo has been canceled.';
                      }
                      if(error.code===5) {
                        msg = 'Something went wrong. Please try again!';
                      }

                      $scope.showAlert('Upload photo failed!', msg);
                  }

                  var options = new FileUploadOptions();
                  options.fileKey="file";
                  options.fileName=fileURL.substr(fileURL.lastIndexOf('/')+1);
                  options.mimeType="image/jpeg";


                  var params = {};
                  params.userid = $scope.user_data.userid;
                  params.access_token = window.localStorage.access_token;

                  options.params = params;


                  var d = new Date();

                  var ft = new FileTransfer();

                  ft.onprogress = function(progressEvent) {
                      if (progressEvent.lengthComputable) {
                        $scope.uploadPersent[index] = ((progressEvent.loaded / progressEvent.total)*100);
                      } else {
                        $scope.uploadPersent[index] = $scope.uploadPersent[index].increment();
                      }
                      document.getElementById("status"+index).style.width = $scope.uploadPersent[index]+'%';
                  };

                  ft.upload(fileURL, encodeURI(server_url+"upload/index?v="+d), win, fail, options);
                  // ft.abort();
            };



        }, false);



    
        // remove image
        $scope.removeImages = function(index){
          // $scope.upload_images.splice(index, 1);
          // $scope.item_image.splice(index, 1);
          delete $scope.item_image[index]; 
          delete $scope.upload_images[index]; 

        };


        // enable button add photo
        $scope.enableAddPhoto = function() {

          var count = 0;
          for (var i1 in $scope.upload_images) {
              if ($scope.upload_images.hasOwnProperty(i1)) {
                  count++;
              }
          }
          for (var i2 in $scope.item_photo) {
              if ($scope.item_photo.hasOwnProperty(i2)) {
                  count++;
              }
          }
          total_image = count;
          if(total_image>=allowNumPhoto) {
            return false;
          }
          return true;
        };

        $scope.get_num_photo = function() {
          return total_image;
        };


        // remove old image
        $scope.removeOldImages = function(index){
          delete $scope.item_data.item_photo[index]; 
        };



      // submit post ads
      $scope.hilight_category = false;
      $scope.submitPostAd = function() {
        $scope.hilight_category = false;
        
        var submit_data = {};
        submit_data.item_data       = $scope.item_data;
        submit_data.item_image      = $scope.item_image;
        submit_data.userid        =  $scope.user_data.userid;
        submit_data.access_token  =  window.localStorage.access_token;

        if(stateName==='repost-item') {
          submit_data.type = 'repost_ad';
        }

        if(!submit_data.item_data.cateid) {
            $scope.hilight_category = true;
            $ionicScrollDelegate.$getByHandle('postContent').scrollTo(0,250);
            return;
        }

        $scope.showLoading();
        var req = {
         method: 'POST',
         url: server_url+'post_free_item?lang='+$rootScope.lang_type,
         headers: {
           'Content-Type': 'application/x-www-form-urlencoded'
         },
         data: $httpParamSerializerJQLike(submit_data),
         'timeout':request_timeout,
        };

        $http(req).success(function(response) {
          $scope.hideLoading();

          if(response.status) {



            $scope.user_data.name = $scope.item_data.name;
            $scope.user_data.phone = $scope.item_data.phone;
            $scope.user_data.location = $scope.item_data.location;
            $scope.user_data.address = $scope.item_data.address;


            window.localStorage.user = JSON.stringify($scope.user_data);
            
             
              $scope.item_data = {};
              $scope.item_image = {};

              $ionicHistory.nextViewOptions({
                disableAnimate: false,
                disableBack: true
              });
              $state.go('manage-items');

              $scope.shortAlert(response.info);

          } else {
            $scope.showAlert($rootScope.lang.err_submit,response.info);
            // $scope.test_image = respon;
          }
        }).error(function(){
          $scope.hideLoading();
          $scope.showAlert($rootScope.lang.err_submit,$rootScope.lang.err_connection);
        });


      };


      // 
      $scope.fn_get_validat = function(val,type) {
        if(val) {
          var res = [];
          res =  val.split("|");

          if(type==='required' && res.indexOf("required")>=0) {
            return true;
          }
          if(type==='minlength') {
            for (var i3 = 0; i3 <= res.length-1; i3++) {
              if(res[i3].indexOf('min_length') >= 0) {
                return parseInt(res[i3].replace( /^\D+/g, ''));
              }
              if(res[i3].indexOf('exact_length') >= 0) {
                return parseInt(res[i3].replace( /^\D+/g, ''));
              }
            }
          }

          if(type==='maxlength') {
            for (var i4 = 0; i4 <= res.length-1; i4++) {
              if(res[i4].indexOf('max_length') >= 0) {
                return parseInt(res[i4].replace( /^\D+/g, ''));
              }
              if(res[i4].indexOf('exact_length') >= 0) {
                return parseInt(res[i4].replace( /^\D+/g, ''));
              }
            }
          }

          if(type==='pattern') {
            for (var i5 = 0; i5 <= res.length-1; i5++) {
              if(res[i5].indexOf('numeric') >= 0) {
                return '\\d+';
              }
            }
          }

          if(type==='type') {
            for (var i5 = 0; i5 <= res.length-1; i5++) {
              if(res[i5].indexOf('numeric') >= 0) {
                return 'number';
              }
            }
            return 'text';
          }

        }
      };



      // 
      $scope.fn_get_input_type = function(val) {
        if(val) {
          var res = [];
          res =  val.validation.split("|");

          if(res.indexOf("numeric")>=0) {
            return "number";
          }

          return val.type;
        }

        return "text";
      };


      // show or hid ad phone
      $scope.show_item_phone_more = true;

      // if($scope.item_data.phone) {
      // $scope.show_item_phone_more = false;
      // }


      $scope.fn_add_more_phone = function() {
        if($scope.show_item_phone2===true) {
          $scope.show_item_phone3 = true;
        }
        if(!$scope.show_item_phone2) {
          $scope.show_item_phone2 = true;
        }
        if($scope.show_item_phone2===true && $scope.show_item_phone3) {
          $scope.show_item_phone_more = false;
        } else {
          $scope.show_item_phone_more = true;
        }
      };
      $scope.fn_remove_phone = function(val) {
        if(val===2) {
          if($scope.item_data.phone[1]) {
            $scope.item_data.phone[1] = '';
            $scope.show_item_phone3 = true;
          } else {
            $scope.show_item_phone2 = false;
            $scope.show_item_phone_more = true;
          }
        }
        if(val===3) {
          if($scope.item_data.phone[2]) {
            $scope.item_data.phone[2] = '';
            $scope.show_item_phone3 = true;
          } else {
            $scope.show_item_phone3 = false;
            $scope.show_item_phone_more = true;
          }
        }
      };


      // fn choose photo
       $scope.fn_choose_photo = function() {

         // Show the action sheet
         var hideSheet = $ionicActionSheet.show({
           buttons: [
             { text: '<span class="icon ion-android-camera"></span> '+$rootScope.lang.btn_take_photo },
             { text: '<span class="icon ion-image"></span> '+$rootScope.lang.btn_add_photo }
           ],
           titleText: 'Ad Photo',
           cancelText: 'Cancel',
           cancel: function() {
                // add cancel code..
              },
           buttonClicked: function(index) {
              hideSheet();
              document.addEventListener('deviceready', function () {
                if(index===0) {
                  $scope.openCamra();
                } else {
                  $scope.browsePhotos();
                }
              },false);
           }
         });
       };

  });


});



// ########## save ads controller ##########
app.controller('saveAdsCtrl', function($scope, $ionicPlatform, $state, $http, $httpParamSerializerJQLike, $ionicPopup, $ionicHistory, $timeout, $rootScope, $cordovaGoogleAnalytics, $cordovaVibration) {

  $ionicPlatform.ready(function() {

    if(!$scope.is_login()) {
      $state.go('my-account');
        $ionicHistory.nextViewOptions({
          disableAnimate: false,
          disableBack: true
        });
        return;
    }
    

    document.addEventListener("deviceready", function () {
        // $cordovaGoogleAnalytics.trackView('Save Ads');
        window.ga.trackView('Save Ads');
    }, false);



    $timeout(function(){
      $scope.check_access_token();
    });    

    $scope.server_connection = true;
    $scope.show_loading_items = true;



    $scope.saveAds = [];
    $scope.count_saveAds = 0;

    $scope.get_saveAds = function() {
      $scope.$broadcast('scroll.refreshComplete');

      $scope.show_loading_items = true;
      $scope.server_connection = true;

      var submit_data = {};
      submit_data.userid = $scope.user_data.userid;
      submit_data.access_token = window.localStorage.access_token;

      var req = {
       method: 'POST',
       url: server_url+'my_save_items',
       headers: {
         'Content-Type': 'application/x-www-form-urlencoded'
       },
       data: $httpParamSerializerJQLike(submit_data),
       'timeout':request_timeout,
      };

      $http(req).success(function(response) {
        $scope.saveAds = response.save_items;
        $scope.count_saveAds = $scope.saveAds.length;

        $scope.show_loading_items = false;

        if($scope.saveAds) {
          var si = [];
          for (var i = 0; i <= $scope.count_saveAds-1; i++) {
            si[i] = {};
            si[i] ={'id':$scope.saveAds[i].id, 'date':$scope.saveAds[i].date};
          }
          window.localStorage.items_saved = JSON.stringify($scope.saveAds);
        } else {
          window.localStorage.items_saved = '';

        }

          $timeout(function(){
            $rootScope.$emit('lazyImg:refresh');
          },150);

      }).error(function(){
        $scope.server_connection = false;
        $scope.show_loading_items = false;
      });

    };



    //  remove save ads
    $scope.fn_remove_save_items = function(adid, index) {

       var confirmPopup = $ionicPopup.confirm({
         title: $rootScope.lang.con_title_remove_save_ad,
         template: $rootScope.lang.con_remove_save_ad
       });


        document.addEventListener('deviceready', function () {
          $cordovaVibration.vibrate(100);
        }, false);

      confirmPopup.then(function(res) {
         if(res) {
              $scope.showLoading();
              var submit_data = {};
              submit_data.userid = $scope.user_data.userid;
              submit_data.access_token = window.localStorage.access_token;
              submit_data.adid =adid;

              var req = {
               method: 'POST',
               url: server_url+'remove_save_item',
               headers: {
                 'Content-Type': 'application/x-www-form-urlencoded'
               },
               data: $httpParamSerializerJQLike(submit_data),
               'timeout':request_timeout,
              };

              $http(req).success(function(response) {

                $scope.hideLoading();

                if(response.status) {
                    $scope.saveAds.splice(index, 1);
                    $scope.count_saveAds = $scope.saveAds.length;
                    $scope.shortAlert(response.info);

                  if($scope.count_saveAds) {
                    var si = [];
                    for (var i = 0; i <= $scope.count_saveAds-1; i++) {
                      si[i] = {};
                      si[i] ={'id':$scope.saveAds[i].id, 'date':$scope.saveAds[i].date};
                    }
                    window.localStorage.items_saved = JSON.stringify($scope.saveAds);
                  } else {
                    window.localStorage.items_saved = '';
                  }


                } else {
                    $scope.showAlert($rootScope.lang.err_remove_save_ad, response.info);
                }

              }).error(function(){
                $scope.hideLoading();
                $scope.shortAlert($rootScope.lang.err_connection);
              });

         } else {

         }
     });

    };
  });

});








// ###################
// acount
// ###################


// ########## account controller ##########
app.controller('accountCtrl', function($scope, $ionicPlatform, $state, $http, $httpParamSerializerJQLike, $ionicActionSheet, $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer, $timeout, $ionicHistory, $rootScope, $cordovaGoogleAnalytics) {

  $ionicPlatform.ready(function() {

    if(!$scope.is_login()) {
      $state.go('my-account');
        $ionicHistory.nextViewOptions({
          disableAnimate: false,
          disableBack: true
        });
        return;
    }

  
    document.addEventListener("deviceready", function () {
        // $cordovaGoogleAnalytics.trackView('Account');
        window.ga.trackView('Account');
    }, false);


    $timeout(function(){
      $scope.check_access_token();
    });

    // ---- get the locations  ----

    $scope.locations = locations;
    $scope.get_locations = function() {
      if($scope.locations.length===0) {
        $http.get(server_url+'get_locations').success(function(response) {
            $scope.locations = response.locations;
            locations = response.locations;
        });
      }
    };
    // ---- end ----

    $scope.user = $scope.user_data;

    $scope.upload_images = [];
    $scope.upload_images.image =  $scope.user_data.photo;
    $scope.upload_images.name = '';
    $scope.upload_images.uploading = false;


    $scope.submit_account_setting = function() {


          $scope.showLoading();

          var submit_data = {};
          submit_data =  $scope.user;
          submit_data.access_token = window.localStorage.access_token;

          var req = {
           method: 'POST',
           url: server_url+'account_setting',
           headers: {
             'Content-Type': 'application/x-www-form-urlencoded'
           },
           data: $httpParamSerializerJQLike(submit_data),
           'timeout':request_timeout,
          };


          $http(req).success(function(response) {

            $scope.hideLoading();

              if(response.status) {
                  $scope.showAlert($rootScope.lang.succss_save, response.info);

                  $scope.user.name = $scope.user.first_name+' '+$scope.user.last_name;
                  if(response.photo) {
                    $scope.user.photo = response.photo;
                  }
                  $scope.user_data = $scope.user;
                  window.localStorage.user = JSON.stringify($scope.user);


              } else {
                $scope.showAlert('Save Failed!', response.info);
              }

          }).error(function(){
            $scope.hideLoading();
            $scope.showAlert('Save failed!', $rootScope.lang.err_connection);
          });

    };



      // show or hid ad phone
      $scope.show_item_phone_more = true;

      if($scope.user.phone.length>=3) {
        $scope.show_item_phone_more = false;
      }


      $scope.fn_add_more_phone = function() {
        if($scope.show_item_phone2===true) {
          $scope.show_item_phone3 = true;
        }
        if(!$scope.show_item_phone2) {
          $scope.show_item_phone2 = true;
        }
        if($scope.show_item_phone2===true && $scope.show_item_phone3) {
          $scope.show_item_phone_more = false;
        } else {
          $scope.show_item_phone_more = true;
        }
      };
      $scope.fn_remove_phone = function(val) {
        if(val===2) {
          if($scope.user.phone[1]) {
            $scope.user.phone[1] = '';
            $scope.show_item_phone3 = true;
          } else {
            $scope.show_item_phone2 = false;
            $scope.show_item_phone_more = true;
          }
        }
        if(val===3) {
          if($scope.user.phone[2]) {
            $scope.user.phone[2] = '';
            $scope.show_item_phone3 = true;
          } else {
            $scope.show_item_phone3 = false;
            $scope.show_item_phone_more = true;
          }
        }
      };




     // action for change photo
     $scope.showActionSheet = function() {

        var options = [{'text': '<span class="icon ion-camera"></span> Take Photo'},{'text': '<span class="icon ion-folder"></span> Upload Photo'}];

       // Show the action sheet
       var hideSheet = $ionicActionSheet.show({
         buttons: options,
         // destructiveText: 'Delete',
         titleText: 'Change Photo',
         cancelText: 'Cancel',
         cancel: function() {
              // add cancel code..
            },
         buttonClicked: function(index) {
            document.addEventListener('deviceready', function () {
              if(index===0) {
                $scope.openCamra();
              } else {
                $scope.browsePhotos();
              }
            },false);
           hideSheet();
         }
       });

       // For example's sake, hide the sheet after two seconds
       // $timeout(function() {
       //   hideSheet();
       // }, 2000);

     };
     // end



      // ######### camara #########
      $scope.openCamra = function() {

            var options = {
              quality: 90,
              destinationType: Camera.DestinationType.FILE_URI,
              sourceType: Camera.PictureSourceType.CAMERA,
              targetWidth: 200,
              targetHeight: 200,
              correctOrientation:true,
              saveToPhotoAlbum: true,
            };

            $cordovaCamera.getPicture(options).then(function(imageURI) {

              // var image = document.getElementById('myImage');
              // image.src = imageURI;
              // fileURL = imageURI;

                  $scope.upload(imageURI);
                  $scope.upload_images = [];
                  $scope.upload_images.image = imageURI;
                  $scope.upload_images.name = '';
                  $scope.upload_images.uploading = true;


            }, function(err) {
              // error
              // $scope.showAlert('Open Camera', 'Cannot detect camara.');
            });
        };


        // ######### browse photo #########
        $scope.browsePhotos = function() {

          var count = 1;
           var options = {
             maximumImagesCount: count,
             width: 200,
             height: 200,
             quality: 90
            };

            $cordovaImagePicker.getPictures(options)
              .then(function (results) {
                for (var i = 0; i < results.length; i++) {

                  // fileURL = results[i];

                  $scope.upload(results[i]);
                  $scope.upload_images = [];
                  $scope.upload_images.image = results[i];
                  $scope.upload_images.name = '';
                  $scope.upload_images.uploading = true;


                }
              }, function(error) {
                // error getting photos
                // alert('err');
              });


        };





        // upload
        $scope.uploadPersent = 0;
        $scope.upload = function(fileURL) {
            

            $scope.uploadPersent = 0;

              function win(r) {
                  var respon_data = JSON.parse(r.response);

                  if(respon_data.status) {
                    $scope.upload_images.name  = respon_data.file;
                    $scope.upload_images.uploading  = false;

                    $scope.user.photo = respon_data.file;

                    document.getElementById("upload_status").remove();
                    document.getElementById("upload_loading").remove();

                  } else {
                    $scope.removeImages();
                    $scope.showAlert('Upload failed!!!', respon_data.info);
                  }
              }

              function fail(error) {

                  $scope.removeImages();

                  // alert("An error has occurred: Code = " + error.code);
                  var msg;
                  if(error.code===1) {
                    msg = 'File not found. Please try again!';
                  }
                  if(error.code===2) {
                    msg = 'Invalid url. Please try again!';
                  }
                  if(error.code===3) {
                    msg = 'Check your connection and try again.';
                  }
                  if(error.code===4) {
                    msg = 'The uploading photo has been canceled.';
                  }
                  if(error.code===5) {
                    msg = 'Something went wrong. Please try again!';
                  }

                  $scope.showAlert('Upload photo failed!', msg);

              }

              var options = new FileUploadOptions();
              options.fileKey="file";
              options.fileName=fileURL.substr(fileURL.lastIndexOf('/')+1);
              options.mimeType="image/jpeg";


              var params = {};
              params.userid = $scope.user_data.userid;
              params.access_token = window.localStorage.access_token;

              options.params = params;


              var d = new Date();

              var ft = new FileTransfer();

              ft.onprogress = function(progressEvent) {
                  if (progressEvent.lengthComputable) {
                    $scope.uploadPersent = ((progressEvent.loaded / progressEvent.total)*100);
                  } else {
                    $scope.uploadPersent = $scope.uploadPersent.increment();
                  }
                  document.getElementById("upload_status").style.width = $scope.uploadPersent[index]+'%';
              };

              ft.upload(fileURL, encodeURI(server_url+"upload/index?v="+d), win, fail, options);
              // ft.abort();
        };






    // remove image
    $scope.removeImages = function(index){
      $scope.upload_images = [];
    };

  });


});




// ########## change PasswordCtrl controller ##########
app.controller('changePasswordCtrl', function($scope, $ionicPlatform, $http, $httpParamSerializerJQLike, $state,  $ionicModal, $stateParams,$ionicHistory, $timeout, $rootScope, $cordovaGoogleAnalytics) {

  $ionicPlatform.ready(function() {

    if(!$scope.is_login()) {
      $state.go('my-account');
        $ionicHistory.nextViewOptions({
          disableAnimate: false,
          disableBack: true
        });
        return;
    }


  document.addEventListener("deviceready", function () {
      // $cordovaGoogleAnalytics.trackView('Change Password');
      window.ga.trackView('Change Password');
  }, false);



  $timeout(function(){
    $scope.check_access_token();
  });
    


  $scope.user = {};
  $scope.submit_change_password = function() {

          $scope.showLoading();

          var submit_data = {};
          submit_data = $scope.user;
          submit_data.userid = $scope.user_data.userid;
          submit_data.access_token = window.localStorage.access_token;

          var req = {
           method: 'POST',
           url: server_url+'change_password',
           headers: {
             'Content-Type': 'application/x-www-form-urlencoded'
           },
           data: $httpParamSerializerJQLike(submit_data),
           'timeout':request_timeout,
          };

          $http(req).success(function(response) {

            if(response.status) {
              $scope.user = {};
              $scope.shortAlert(response.info);
            } else {
              $scope.showAlert($rootScope.lang.err_submit, response.info);
            }

            $scope.hideLoading();
          }).error(function(){
            $scope.hideLoading();
            $scope.showAlert($rootScope.lang.err_submit, $rootScope.lang.err_connection);
          });


    };

  });

});



// ########## set map controller ##########
app.controller('setMapCtrl', function($scope, $ionicPlatform, $state, $http, $httpParamSerializerJQLike, $cordovaGeolocation, $rootScope, $ionicHistory, $timeout, $cordovaGoogleAnalytics) {

  $ionicPlatform.ready(function() {

    $scope.server_connection = true;
    if(!$scope.is_login()) {
      $state.go('my-account');
        $ionicHistory.nextViewOptions({
          disableAnimate: false,
          disableBack: true
        });
        return;
    }


    document.addEventListener("deviceready", function () {
        // $cordovaGoogleAnalytics.trackView('Set Map');
        window.ga.trackView('Set Map');
    }, false);


    $timeout(function(){
      $scope.check_access_token();
    });

    var user = window.localStorage.user;
    if(user) {
      user = JSON.parse(user);
    }

  // google map

    $scope.map = {};

    var map;
    var marker;

    $scope.fn_showMap = function() {

      setTimeout(function(){

        $scope.map.x = 11.5796669;
        $scope.map.y = 104.7501022;
        $scope.map.z = 6;

        if(user.map.x && user.map.y && user.map.z) {

            var m = user.map;
            $scope.map.x = parseFloat(m.x);
            $scope.map.y = parseFloat(m.y);
            $scope.map.z = parseInt(m.z);
        }

        var myLatLng;

        function initialize() {
            myLatLng = {lat: $scope.map.x, lng: $scope.map.y};
            map = new google.maps.Map(document.getElementById('setmap'), {
              center: myLatLng,
              zoom: $scope.map.z,
            });

            marker = new google.maps.Marker({
                position: myLatLng,
                map: map,
                draggable: true,
              });


            // for move marker
            google.maps.event.addListener(marker,'dragend',function(e) {
                  map.panTo(marker.getPosition());
                  $scope.map.x = e.latLng.lat();
                  $scope.map.y = e.latLng.lng();
            }); 
      


            // set maker by click
            google.maps.event.addListener(map, 'click', function(e) {
              marker.setPosition(e.latLng);   
              map.panTo(e.latLng);           
              $scope.map.x = e.latLng.lat();
              $scope.map.y = e.latLng.lng();
            });
                

            // for move marker when screen change
            google.maps.event.addDomListener(window, "resize", function(e) {
              window.setTimeout(function() {
                map.panTo(marker.getPosition());
                $scope.map.x = marker.getPosition().lat();
                $scope.map.y = marker.getPosition().lng();
              },100);
            });


            }

            initialize();

         }, 300);
      
    };
    $scope.fn_showMap();
    // end


    // detect location
    $scope.detect_location = function() {
      $scope.showLoading();
      var posOptions = {timeout: 10000, enableHighAccuracy: false};
      $cordovaGeolocation
        .getCurrentPosition(posOptions)
        .then(function (position) {
          $scope.hideLoading();
          
          $scope.map.x = position.coords.latitude;
          $scope.map.y = position.coords.longitude;

          var p = {lat: $scope.map.x, lng: $scope.map.y};
          map.panTo(p);
          marker.setPosition(p); 
          map.setZoom(16);

          $scope.map.z = map.getZoom();

        }, function(err) {
          // error
          $scope.hideLoading();
          $scope.showAlert($rootScope.err_delete, $rootScope.lang.con_detect_map);
        });
    };




    // submit map
    $scope.SubmitMap = function() {

        if($rootScope.connection==='OFF') {
          $scope.shortAlert($rootScope.lang.err_connection);
          return;
        }

        $scope.showLoading();
        var submit_data = {};
        submit_data = $scope.map;
        submit_data.userid = $scope.user_data.userid;
        submit_data.access_token = window.localStorage.access_token;

        var req = {
         method: 'POST',
         url: server_url+'set_map',
         headers: {
           'Content-Type': 'application/x-www-form-urlencoded'
         },
         data: $httpParamSerializerJQLike(submit_data),
         'timeout':request_timeout,
        };

        $http(req).success(function(response) {
          $scope.hideLoading();
          if(response.status===1) {
            $scope.shortAlert(response.info);
            var p = {lat: $scope.map.x, lng: $scope.map.y};
            map.panTo(p);

            user.map = {'x':$scope.map.x, 'y':$scope.map.y, 'z': 17};
            $scope.user_data = user;
            window.localStorage.user          = JSON.stringify(user);

          } else {
            $scope.showAlert('Submit failed!', response.info);
          }
        }).error(function(){
          $scope.server_connection = false;
          $scope.hideLoading();
          $scope.$broadcast('scroll.refreshComplete');
          $scope.showAlert($rootScope.lang.err_connection_title_dialog, $rootScope.lang.err_connection);
        });
    };
  });

});




// ###################
// setting
// ###################

app.controller('settingCtrl', function($scope, $ionicPlatform, $http, $httpParamSerializerJQLike, $state, $stateParams,$ionicHistory, $timeout, $rootScope) {

  $ionicPlatform.ready(function() {

    // set notification
    $scope.setting_notification = window.localStorage.notification;

    if($scope.setting_notification==='false') {
      $scope.setting_notification = false;

    } else {
      $scope.setting_notification = true;
    }

    $scope.notification_setting = function(val) {

      document.addEventListener("deviceready", function () {

          var submit_data = {};
          submit_data.model = $rootScope.device.model;
          submit_data.version = $rootScope.device.version;
          submit_data.platform = $rootScope.device.platform;
          submit_data.device_id = $rootScope.device.uuid;
          submit_data.app_version = $rootScope.device.app_version;
          submit_data.notification = val;
        
          var req = {
           method: 'POST',
           url: server_url+'notification',
           headers: {
             'Content-Type': 'application/x-www-form-urlencoded'
           },
           data: $httpParamSerializerJQLike(submit_data),
           'timeout':request_timeout,
          };

          $http(req).success(function(response) {
            if(response.status===1) {
              window.localStorage.notification = val;
            } else {
              $scope.shortAlert($rootScope.lang.err_default);
            }
            
          }).error(function(){
              $scope.setting_notification = window.localStorage.notification;
              if($scope.setting_notification==='false') {
                $scope.setting_notification = false;
              } else {
                $scope.setting_notification = true;
              }
            $scope.shortAlert($rootScope.lang.err_connection);
          });

      },false);
    };
    // 
  });

});



// select banner
var banner_user;
app.controller('slideSettingCtrl', function($scope, $ionicPlatform, $http, $httpParamSerializerJQLike, $state, $stateParams,$ionicHistory, $timeout, $rootScope) {

  $ionicPlatform.ready(function() {

    $scope.show_inline_loading = true;

    // get banner user
    $scope.item = [];
    $scope.get_banner_user = function(){

      if(banner_user) {
        $scope.item = banner_user;
        $scope.show_inline_loading = false;
        checkActiveBanner();
      } else {
        var req = {
         method: 'get',
         url: server_url+'banner_user',
         headers: {
           'Content-Type': 'application/x-www-form-urlencoded'
         },
         'timeout':request_timeout,
        };

        $http(req).success(function(response) {
          $scope.show_inline_loading = false;
          banner_user = response.item;
          $scope.item = response.item;
          checkActiveBanner();
        }).error(function(){
          $scope.show_inline_loading = 'error';
        });
      }
    };

    function checkActiveBanner() {
        var active = window.localStorage.slideSetting;

        if(active) {
          active = JSON.parse(active);
        } else {
          active = [];
        }


        for(var i in $scope.item) {
          if(active.indexOf($scope.item[i].id)>=0 || (active.length<1 && $scope.item[i].is_default===1)) {
            $scope.item[i].checked = true;
          } else {
            $scope.item[i].checked = false;
          }
        }

    }
    $scope.get_banner_user();


    // submit
    $scope.submit_banner_setting = function(val) {
      var active = [];
      for(var i in $scope.item) {
        if($scope.item[i].checked===true) {
          active[i] = $scope.item[i].id;
        }
      }
      update_slide = false;
      window.localStorage.slideSetting = JSON.stringify(active);
      $state.go('index');
    };

  });
});







// ###################
// directive
// ###################

var timer;
app.directive('scrollWatch', function($rootScope, $ionicScrollDelegate, $timeout) {
  return function(scope, elem, attr) {
    var start = 0;
    var threshold = 100;

    
    elem.bind('scroll', function(e) {

      

      if(elem[0].scrollTop - start > threshold) {
        $rootScope.slideHeader = true;
      } else {
        $rootScope.slideHeader = false;
      }


      if (elem[0].scrollTop - start < $rootScope.slideHeaderPrevious) {
            $rootScope.slideHeader = false;
      }

      var t = 900;
      clearTimeout(timer);
      timer = setTimeout( function() {$rootScope.$emit('lazyImg:refresh'); },t);

      $rootScope.slideHeaderPrevious = (elem[0].scrollTop - start);
      $rootScope.$apply();
    });
  };
});


// // show connection error
app.directive('internetConnection', function($rootScope, $cordovaNetwork, $ionicPlatform) {
  
    var html = '';
    $ionicPlatform.ready(function() {
        html += '<div class="no-connection padding text-center">';
        html += '<div class="image">';
        html += '<span class="icon ion-android-wifi"></span>';
        html += '</div>';
        html += '<div class="status">';
        html += '<div class="big">'+$rootScope.lang.err_connection_title+'</div>';
        html += '<div class="small">'+$rootScope.lang.err_connection_info+'</div>';
        html += '</div>';
        html += '</div>';
        });

    return {
        template : html
    };
  
});


// detect image to set full div
app.directive('imageFit', function(){ 
   return {
     restrict: 'A',
     link: function(scope, elem, attr) {
         elem.on('load', function() {
            var w = elem[0].width,
                h = elem[0].height;

                if(w>h) {
                  elem.addClass('img-width');
                  elem.removeClass('img-height');
                  elem.removeClass('img-equal');
                }

                if(w<h) {
                  elem.addClass('img-height');
                  elem.removeClass('img-equal');
                  elem.removeClass('img-width');
                }

                if(w===h) {
                  elem.addClass('img-equal');
                  elem.removeClass('img-height');
                  elem.removeClass('img-width');
                }
                

            //check width and height and apply styling to parent here.
         });
     }
   };
});


// autofocus error
app.directive('accessibleForm', function ($timeout) {
    return {
        restrict: 'A',
        link: function (scope, elem) {

            // set up event handler on the form element
            elem.on('click', function (e) {
              if(e.target.type==='submit') {
                // find the first invalid element
                var firstInvalid = elem[0].querySelector('.ng-invalid');

                // if we find one, set focus
                if (firstInvalid) {
                  $timeout(function() { firstInvalid.focus();}, 150);
                }
              }
            });
        }
    };
});

app.directive('stringToNumber', function() {
  return {
    require: 'ngModel',
    link: function(scope, element, attrs, ngModel) {
      ngModel.$parsers.push(function(value) {
        return '' + value;
      });
      ngModel.$formatters.push(function(value) {
        return parseFloat(value);
      });
    }
  };
});